/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

#include"ArBMP.hpp"
#include"../Console/Commande.hpp"

namespace BigCrunch
{
	ArBMP::ArBMP(const char *nomFichier, ModeCodeur mode) : Codeur(nomFichier, mode)
	{
		_borneInf = 0;
		_borneSup = 0xffffffff;
	}

	ArBMP::ArBMP(const char *nomFichier, ModeCodeur mode, const char *nomSortie) : Codeur(nomFichier, mode, nomSortie)
	{
		_borneInf = 0;
		_borneSup = 0xffffffff;
	}
#ifndef SFX
	//Gerer le preparer
	const char *ArBMP::compresser()
	{
//////////////////////////////////////////////////////////////
//test si c'est bien un fichier bmp valide non compresser (en rle) et en 24 bits
	U32 largeurImage, hauteurImage;
	EFichierMauvais MF;
	U16 pixelDepth;

	try
	{
		U16 test;
		U32 compress;
		U32 typeBMP;
		U32 imageStart;

		//est-ce un bmp?
		test = _entree->lireU16();
		if (!((test == 0x4d42) || (test == 0x4142) || (test == 0x4943) ||
			(test == 0x5043) || (test == 0x4349) || (test == 0x5450)))
		{
			throw MF;
		}

		//debut de l'image
		_entree->avancer(8);
		imageStart = _entree->lireU32();
		//printf("imageStart: %d\n", imageStart);

		//type de fichier bmp 28=bmp win // 38=bmp de la forme 16 bits A1B5V5R5
		typeBMP = _entree->lireU32(); // soit 28 soit 38

		//largeur de l'image en pixel
		largeurImage = _entree->lireU32();
		//hauteur de l'image en pixel
		hauteurImage = _entree->lireU32();

		//codage sur 16/24/32 bits?
		_entree->avancer(2);
		pixelDepth = _entree->lireU16();
		if (!((pixelDepth == 16) || (pixelDepth == 24) || (pixelDepth == 32)))
		{
			//printf("pas un 16/24/32 bits: %0x\n", pixelDepth);
			throw MF;
		}

		//est-ce deja compresse?
		compress = _entree->lireU32();
		if ((compress) && (typeBMP == 28))
		{
			//printf("deja conmpresse: %0x\n", compress);
			throw MF;
		}

		//ecrir le debut du fichier bmp qui ne sera pas compresse
		_entree->rembobiner();
		for (uint i = 0; i < imageStart; ++i)
		{
			_sortie->ecrireOctet(_entree->lireOctet());
		}
	}
	catch (...)
	{
		throw MF;
	}
//////////////////////////////////////////////////////////////

		//printf("image %d bits\n", pixelDepth);

		//choix selon 16/24/32
		switch (pixelDepth)
		{
			case 16:
				ArBMP16Compr1555(largeurImage, hauteurImage);
				break;
			case 24:
				ArBMP24Compr(largeurImage, hauteurImage);
				break;
			case 32:
				ArBMP32Compr(largeurImage, hauteurImage);
				break;
			default:
				printf("pixelDepth inconnue\n");
				break;
		}

		return _nomSortie;
	}
#endif
	const char *ArBMP::decompresser()
	{
		int tailleHeader;
		int largeurImage, hauteurImage;
		int pixelDepth;

//////////////////////////////////////////////////////////////////////
//ecrit le header du bmp dans le fichier de sortie
		//recuperer la taille du header (ou la position du debut de l'image) pour le recopier
		_entree->avancer(10);
		tailleHeader = _entree->lireU32();

		//recuperer la largeur de l'image pour compter les ligne incomplete (telle que ((taille * 3) % 4) == 0)
		_entree->avancer(4);
		largeurImage = _entree->lireU32();
		//hauteur de l'image en pixel
		hauteurImage = _entree->lireU32();

		//codage sur 16/24/32 bits?
		_entree->avancer(2);
		pixelDepth = _entree->lireU16();

		_entree->rembobiner();

		for (int i = 0; i < tailleHeader; ++i)
		{
			_sortie->ecrireOctet(_entree->lireOctet());
		}
//////////////////////////////////////////////////////////////////////

		//choix selon 16/24/32
		switch (pixelDepth)
		{
			case 16:
				ArBMP16Decompr1555(largeurImage, hauteurImage);
				break;
			case 24:
				ArBMP24Decompr(largeurImage, hauteurImage);
				break;
			case 32:
				ArBMP32Decompr(largeurImage, hauteurImage);
				break;
			default:
				printf("pixelDepth inconnue\n");
				break;
		}

		return _nomSortie;
	}
#ifndef SFX
/////////////////////////////////////////////////////////////////////////
	void ArBMP::ArBMP32Compr(int largeurImage, int hauteurImage)
	{
		U8	 buffer;

		//init les variables de parcours du fichier
		int composante = 0;
		int positionLargeur = 0;

		// Valeurs pour le codage par distance
		/*int largeurComposantes = largeurImage * 4;
		U8 *valeur = new U8[largeurComposantes];
		for (int i = 0; i < largeurComposantes; ++i)
		{
			valeur[i] = _entree->lireOctet();
		}
		_entree->rembobiner(largeurComposantes);*/

		//init la variable qui donne le nombre de 0 a passer a chaque fin de 'ligne' de pixel
		int nbZeroAPasser;
		nbZeroAPasser = nbZero(largeurImage * 4);

		while (composante < (largeurImage * hauteurImage * 4))
		{
			try
			{
				buffer = _entree->lireOctet();

				/*buffer -= valeur[positionLargeur % largeurComposantes];
				valeur[positionLargeur % largeurComposantes] += buffer;*/

				++positionLargeur;
				afficherProgression();
			}
			catch (EFinFichier &)
			{
				break;
			}

			switch (composante % 4)
			{
				case 0:
					for ( int i = 7; i >= 0; --i)
					{
						if ((buffer >> i) & 1) //si le bit courant est un 1
						{
							_borneSup = _borneInf + (((_borneSup - _borneInf) >> 12) * P0.p());
							P0.apprendre(1);
						}
						else
						{
							_borneInf = _borneInf + (((_borneSup - _borneInf) >> 12)  * P0.p()) + 1;
							P0.apprendre(0);
						}
						while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
						{
							_sortie->ecrireOctet((U8)(_borneInf >> 24));
							_borneInf <<= 8;
							_borneSup = (_borneSup << 8) + 0x000000ff;
						}
					}
					break;
				case 1:
					for ( int i = 7; i >= 0; --i)
					{
						if ((buffer >> i) & 1) //si le bit courant est un 1
						{
							_borneSup = _borneInf + (((_borneSup - _borneInf) >> 12) * P1.p());
							P1.apprendre(1);
						}
						else
						{
							_borneInf = _borneInf + (((_borneSup - _borneInf) >> 12)  * P1.p()) + 1;
							P1.apprendre(0);
						}
						while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
						{
							_sortie->ecrireOctet((U8)(_borneInf >> 24));
							_borneInf <<= 8;
							_borneSup = (_borneSup << 8) + 0x000000ff;
						}
					}
					break;
				case 2:
					for ( int i = 7; i >= 0; --i)
					{
						if ((buffer >> i) & 1) //si le bit courant est un 1
						{
							_borneSup = _borneInf + (((_borneSup - _borneInf) >> 12) * P2.p());
							P2.apprendre(1);
						}
						else
						{
							_borneInf = _borneInf + (((_borneSup - _borneInf) >> 12)  * P2.p()) + 1;
							P2.apprendre(0);
						}
						while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
						{
							_sortie->ecrireOctet((U8)(_borneInf >> 24));
							_borneInf <<= 8;
							_borneSup = (_borneSup << 8) + 0x000000ff;
						}
					}
					break;
				case 3:
					for ( int i = 7; i >= 0; --i)
					{
						if ((buffer >> i) & 1) //si le bit courant est un 1
						{
							_borneSup = _borneInf + (((_borneSup - _borneInf) >> 12) * P3.p());
							P3.apprendre(1);
						}
						else
						{
							_borneInf = _borneInf + (((_borneSup - _borneInf) >> 12)  * P3.p()) + 1;
							P3.apprendre(0);
						}
						while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
						{
							_sortie->ecrireOctet((U8)(_borneInf >> 24));
							_borneInf <<= 8;
							_borneSup = (_borneSup << 8) + 0x000000ff;
						}
					}
					break;
				default:
					printf("composante inconnue\n");
					break;
			}
			++composante;

			if (positionLargeur == (4 * largeurImage))
			{
				_entree->avancer(nbZeroAPasser);//passer les 0 qui completent la ligne
				positionLargeur = 0;
			}
		}

		_sortie->ecrireOctet((U8)(_borneSup  >> 24));
	}
#endif
	void ArBMP::ArBMP32Decompr(int largeurImage, int hauteurImage)
	{
		U16  buffer;
		U32  pivot,
			 reel;
		int  i;

		i 	   = 0;
		reel   = 0;
		buffer = 0;

		//init la variable qui donne le nombre de 0 a rajouter a chaque fin de 'ligne' de pixel
		int nbZeroAEcrire;
		nbZeroAEcrire = nbZero(largeurImage * 4);
		//printf("nbZeroAEcrire: %d\n", nbZeroAEcrire);

		while (i < 4)
		{
			try
			{
				buffer = _entree->lireOctet();
			}
			catch (EFinFichier &)
			{
				buffer = 0;
			}
			reel = (reel << 8) + buffer;
			buffer = 0;
			++i;
		}

		int composante = 0;

		while (composante < (largeurImage * hauteurImage * 4))
		{
			afficherProgression();

			switch (composante % 4)
			{
				case 0:
					for (uint i = 0; i < 8; ++i)
					{
						pivot = _borneInf + (((_borneSup - _borneInf) >> 12) * P0.p());
						if ( reel <= pivot)
						{
							_sortie->ecrireBit(1);
							P0.apprendre(1);
							_borneSup = pivot;
						}
						else
						{
							_sortie->ecrireBit(0);
							P0.apprendre(0);
							_borneInf = pivot + 1;
						}

						while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
						{
							_borneInf <<= 8;
							_borneSup = (_borneSup << 8) + 0x000000ff;
							try
							{
								buffer = _entree->lireOctet();
							}
							catch(EFinFichier &)
							{
								buffer  = 0;
							}
							reel = (reel << 8) + buffer;
						}
					}
					break;
				case 1:
					for (uint i = 0; i < 8; ++i)
					{
						pivot = _borneInf + (((_borneSup - _borneInf) >> 12) * P1.p());
						if ( reel <= pivot)
						{
							_sortie->ecrireBit(1);
							P1.apprendre(1);
							_borneSup = pivot;
						}
						else
						{
							_sortie->ecrireBit(0);
							P1.apprendre(0);
							_borneInf = pivot + 1;
						}

						while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
						{
							_borneInf <<= 8;
							_borneSup = (_borneSup << 8) + 0x000000ff;
							try
							{
								buffer = _entree->lireOctet();
							}
							catch(EFinFichier &)
							{
								buffer  = 0;
							}
							reel = (reel << 8) + buffer;
						}
					}
					break;
				case 2:
					for (uint i = 0; i < 8; ++i)
					{
						pivot = _borneInf + (((_borneSup - _borneInf) >> 12) * P2.p());
						if ( reel <= pivot)
						{
							_sortie->ecrireBit(1);
							P2.apprendre(1);
							_borneSup = pivot;
						}
						else
						{
							_sortie->ecrireBit(0);
							P2.apprendre(0);
							_borneInf = pivot + 1;
						}

						while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
						{
							_borneInf <<= 8;
							_borneSup = (_borneSup << 8) + 0x000000ff;
							try
							{
								buffer = _entree->lireOctet();
							}
							catch(EFinFichier &)
							{
								buffer  = 0;
							}
							reel = (reel << 8) + buffer;
						}
					}
					break;
				case 3:
					for (uint i = 0; i < 8; ++i)
					{
						pivot = _borneInf + (((_borneSup - _borneInf) >> 12) * P3.p());
						if ( reel <= pivot)
						{
							_sortie->ecrireBit(1);
							P3.apprendre(1);
							_borneSup = pivot;
						}
						else
						{
							_sortie->ecrireBit(0);
							P3.apprendre(0);
							_borneInf = pivot + 1;
						}

						while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
						{
							_borneInf <<= 8;
							_borneSup = (_borneSup << 8) + 0x000000ff;
							try
							{
								buffer = _entree->lireOctet();
							}
							catch(EFinFichier &)
							{
								buffer  = 0;
							}
							reel = (reel << 8) + buffer;
						}
					}
					break;
			}

			++composante;
			if ((composante % (largeurImage * 4)) == 0)
			{
				for (int i = 0; i < nbZeroAEcrire; ++i)//ecrir le nombre de 0 qui faut pour completer la ligne
				{
					_sortie->ecrireOctet(0);
				}
			}
		}
	}
#ifndef SFX
/////////////////////////////////////////////////////////////////////////
	void ArBMP::ArBMP24Compr(int largeurImage, int hauteurImage)
	{
		U8	 buffer;

		//init les variables de parcours du fichier
		int composante = 0;
		int positionLargeur = 0;

		// Valeurs pour le codage par distance
		/*int largeurComposantes = largeurImage * 3;
		U8 *valeur = new U8[largeurComposantes];
		for (int i = 0; i < largeurComposantes; ++i)
		{
			valeur[i] = _entree->lireOctet();
		}
		_entree->rembobiner(largeurComposantes);*/

		//init la variable qui donne le nombre de 0 a passer a chaque fin de 'ligne' de pixel
		int nbZeroAPasser;
		nbZeroAPasser = nbZero(largeurImage * 3);
		//printf("nbZeroAPasser: %d\n", nbZeroAPasser);

		while (composante < (largeurImage * hauteurImage * 3))
		{
			try
			{
				buffer = _entree->lireOctet();

				/*buffer -= valeur[positionLargeur % largeurComposantes];
				valeur[positionLargeur % largeurComposantes] += buffer;*/

				++positionLargeur;
				afficherProgression();
			}
			catch (EFinFichier &)
			{
				break;
			}

			switch (composante % 3)
			{
				case 0:
					for ( int i = 7; i >= 0; --i)
					{
						if ((buffer >> i) & 1) //si le bit courant est un 1
						{
							_borneSup = _borneInf + (((_borneSup - _borneInf) >> 12) * P0.p());
							P0.apprendre(1);
						}
						else
						{
							_borneInf = _borneInf + (((_borneSup - _borneInf) >> 12)  * P0.p()) + 1;
							P0.apprendre(0);
						}
						while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
						{
							_sortie->ecrireOctet((U8)(_borneInf >> 24));
							_borneInf <<= 8;
							_borneSup = (_borneSup << 8) + 0x000000ff;
						}
					}
					break;
				case 1:
					for ( int i = 7; i >= 0; --i)
					{
						if ((buffer >> i) & 1) //si le bit courant est un 1
						{
							_borneSup = _borneInf + (((_borneSup - _borneInf) >> 12) * P1.p());
							P1.apprendre(1);
						}
						else
						{
							_borneInf = _borneInf + (((_borneSup - _borneInf) >> 12)  * P1.p()) + 1;
							P1.apprendre(0);
						}
						while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
						{
							_sortie->ecrireOctet((U8)(_borneInf >> 24));
							_borneInf <<= 8;
							_borneSup = (_borneSup << 8) + 0x000000ff;
						}
					}
					break;
				case 2:
					for ( int i = 7; i >= 0; --i)
					{
						if ((buffer >> i) & 1) //si le bit courant est un 1
						{
							_borneSup = _borneInf + (((_borneSup - _borneInf) >> 12) * P2.p());
							P2.apprendre(1);
						}
						else
						{
							_borneInf = _borneInf + (((_borneSup - _borneInf) >> 12)  * P2.p()) + 1;
							P2.apprendre(0);
						}
						while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
						{
							_sortie->ecrireOctet((U8)(_borneInf >> 24));
							_borneInf <<= 8;
							_borneSup = (_borneSup << 8) + 0x000000ff;
						}
					}
					break;
				default:
					printf("composante inconnue\n");
					break;
			}
			++composante;

			if (positionLargeur == (3 * largeurImage))
			{
				_entree->avancer(nbZeroAPasser);//passer les 0 qui completent la ligne
				positionLargeur = 0;
			}
		}

		_sortie->ecrireOctet((U8)(_borneSup  >> 24));
	}
#endif
	void ArBMP::ArBMP24Decompr(int largeurImage, int hauteurImage)
	{
		U16  buffer;
		U32  pivot,
			 reel;
		int  i;

		i 	   = 0;
		reel   = 0;
		buffer = 0;

		//init la variable qui donne le nombre de 0 a rajouter a chaque fin de 'ligne' de pixel
		int nbZeroAEcrire;
		nbZeroAEcrire = nbZero(largeurImage * 3);
		//printf("nbZeroAEcrire: %d\n", nbZeroAEcrire);

		while (i < 4)
		{
			try
			{
				buffer = _entree->lireOctet();
			}
			catch (EFinFichier &)
			{
				buffer = 0;
			}
			reel = (reel << 8) + buffer;
			buffer = 0;
			++i;
		}

		int composante = 0;

		while (composante < (largeurImage * hauteurImage * 3))
		{
			afficherProgression();

			switch (composante % 3)
			{
				case 0:
					for ( int i = 7; i >= 0; --i)
					{
						pivot = _borneInf + (((_borneSup - _borneInf) >> 12) * P0.p());
						if ( reel <= pivot)
						{
							_sortie->ecrireBit(1);
							P0.apprendre(1);
							_borneSup = pivot;
						}
						else
						{
							_sortie->ecrireBit(0);
							P0.apprendre(0);
							_borneInf = pivot + 1;
						}

						while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
						{
							_borneInf <<= 8;
							_borneSup = (_borneSup << 8) + 0x000000ff;
							try
							{
								buffer = _entree->lireOctet();
							}
							catch(EFinFichier &)
							{
								buffer  = 0;
							}
							reel = (reel << 8) + buffer;
						}
					}
					break;
				case 1:
					for ( int i = 7; i >= 0; --i)
					{
						pivot = _borneInf + (((_borneSup - _borneInf) >> 12) * P1.p());
						if ( reel <= pivot)
						{
							_sortie->ecrireBit(1);
							P1.apprendre(1);
							_borneSup = pivot;
						}
						else
						{
							_sortie->ecrireBit(0);
							P1.apprendre(0);
							_borneInf = pivot + 1;
						}

						while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
						{
							_borneInf <<= 8;
							_borneSup = (_borneSup << 8) + 0x000000ff;
							try
							{
								buffer = _entree->lireOctet();
							}
							catch(EFinFichier &)
							{
								buffer  = 0;
							}
							reel = (reel << 8) + buffer;
						}
					}
					break;
				case 2:
					for ( int i = 7; i >= 0; --i)
					{
						pivot = _borneInf + (((_borneSup - _borneInf) >> 12) * P2.p());
						if ( reel <= pivot)
						{
							_sortie->ecrireBit(1);
							P2.apprendre(1);
							_borneSup = pivot;
						}
						else
						{
							_sortie->ecrireBit(0);
							P2.apprendre(0);
							_borneInf = pivot + 1;
						}

						while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
						{
							_borneInf <<= 8;
							_borneSup = (_borneSup << 8) + 0x000000ff;
							try
							{
								buffer = _entree->lireOctet();
							}
							catch(EFinFichier &)
							{
								buffer  = 0;
							}
							reel = (reel << 8) + buffer;
						}
					}
					break;
			}

			++composante;
			if ((composante % (largeurImage * 3)) == 0)
			{
				for (int i = 0; i < nbZeroAEcrire; ++i)//ecrir le nombre de 0 qui faut pour completer la ligne
				{
					_sortie->ecrireOctet(0);
				}
			}

		}
	}
#ifndef SFX
/////////////////////////////////////////////////////////////////////////
	void ArBMP::ArBMP16Compr1555(int largeurImage, int hauteurImage)
	{
		U16	 buffer;
		int positionLargeur = 0;

		//init la variable qui donne le nombre de 0 a passer a chaque fin de 'ligne' de pixel
		int nbZeroAPasser;
		nbZeroAPasser = nbZero(largeurImage * 2);
		//printf("nbZeroAPasser: %d\n", nbZeroAPasser);

		for (int i = 0; i < (largeurImage * hauteurImage); ++i)
		{
			try
			{
				buffer = _entree->lireU16();
				afficherProgression();
			}
			catch (EFinFichier &)
			{
				break;
			}

			// composante 0 (1xxx)
			if ((buffer >> 15) & 1) //si le bit courant est un 1
			{
				_borneSup = _borneInf + (((_borneSup - _borneInf) >> 12) * P0.p());
				P0.apprendre(1);
			}
			else
			{
				_borneInf = _borneInf + (((_borneSup - _borneInf) >> 12)  * P0.p()) + 1;
				P0.apprendre(0);
			}
			while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
			{
				_sortie->ecrireOctet((U8)(_borneInf >> 24));
				_borneInf <<= 8;
				_borneSup = (_borneSup << 8) + 0x000000ff;
			}

			// composante 1 (x5xx)
			for (int i = 14; i >= 10; --i)
			{
				if ((buffer >> i) & 1) //si le bit courant est un 1
				{
					_borneSup = _borneInf + (((_borneSup - _borneInf) >> 12) * P1.p());
					P1.apprendre(1);
				}
				else
				{
					_borneInf = _borneInf + (((_borneSup - _borneInf) >> 12)  * P1.p()) + 1;
					P1.apprendre(0);
				}
				while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
				{
					_sortie->ecrireOctet((U8)(_borneInf >> 24));
					_borneInf <<= 8;
					_borneSup = (_borneSup << 8) + 0x000000ff;
				}
			}

			// composante 2 (xx5x)
			for (int i = 9; i >= 5; --i)
			{
				if ((buffer >> i) & 1) //si le bit courant est un 1
				{
					_borneSup = _borneInf + (((_borneSup - _borneInf) >> 12) * P2.p());
					P2.apprendre(1);
				}
				else
				{
					_borneInf = _borneInf + (((_borneSup - _borneInf) >> 12)  * P2.p()) + 1;
					P2.apprendre(0);
				}
				while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
				{
					_sortie->ecrireOctet((U8)(_borneInf >> 24));
					_borneInf <<= 8;
					_borneSup = (_borneSup << 8) + 0x000000ff;
				}
			}

			// composante 3 (xxx5)
			for (int i = 4; i >= 0; --i)
			{
				if ((buffer >> i) & 1) //si le bit courant est un 1
				{
					_borneSup = _borneInf + (((_borneSup - _borneInf) >> 12) * P3.p());
					P3.apprendre(1);
				}
				else
				{
					_borneInf = _borneInf + (((_borneSup - _borneInf) >> 12)  * P3.p()) + 1;
					P3.apprendre(0);
				}
				while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
				{
					_sortie->ecrireOctet((U8)(_borneInf >> 24));
					_borneInf <<= 8;
					_borneSup = (_borneSup << 8) + 0x000000ff;
				}
			}

			++positionLargeur;
			if (positionLargeur == largeurImage)
			{
				_entree->avancer(nbZeroAPasser);//passer les 0 qui completent la ligne
				positionLargeur = 0;
			}
		}

		_sortie->ecrireOctet((U8)(_borneSup >> 24));
	}
#endif
	void ArBMP::ArBMP16Decompr1555(int largeurImage, int hauteurImage)
	{
		U16  buffer;
		U32  pivot,
			 reel;
		int  i;

		i 	   = 0;
		reel   = 0;
		buffer = 0;

		//init la variable qui donne le nombre de 0 a rajouter a chaque fin de 'ligne' de pixel
		int nbZeroAEcrire;
		nbZeroAEcrire = nbZero(largeurImage * 2);
		//printf("nbZeroAEcrire: %d\n", nbZeroAEcrire);

		while (i < 4)
		{
			try
			{
				buffer = _entree->lireOctet();
			}
			catch (EFinFichier &)
			{
				buffer = 0;
			}
			reel = (reel << 8) + buffer;
			buffer = 0;
			++i;
		}

		int positionLargeur = 0;
		U16 bufferEcriture = 0;

		for (int i = 0; i < (largeurImage * hauteurImage); ++i)
		{
			afficherProgression();

			// composante 0 (1xxx)
			pivot = _borneInf + (((_borneSup - _borneInf) >> 12) * P0.p());
			if ( reel <= pivot)
			{
				bufferEcriture = 1;
				P0.apprendre(1);
				_borneSup = pivot;
			}
			else
			{
				bufferEcriture = 0;
				P0.apprendre(0);
				_borneInf = pivot + 1;
			}

			while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
			{
				_borneInf <<= 8;
				_borneSup = (_borneSup << 8) + 0x000000ff;
				try
				{
					buffer = _entree->lireOctet();
				}
				catch (EFinFichier &)
				{
					buffer  = 0;
				}
				reel = (reel << 8) + buffer;
			}

			// composante 1 (x5xx)
			for (int i = 0; i < 5; ++i)
			{
				pivot = _borneInf + (((_borneSup - _borneInf) >> 12) * P1.p());
				bufferEcriture <<= 1;
				if ( reel <= pivot)
				{
					bufferEcriture += 1;
					P1.apprendre(1);
					_borneSup = pivot;
				}
				else
				{
					P1.apprendre(0);
					_borneInf = pivot + 1;
				}

				while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
				{
					_borneInf <<= 8;
					_borneSup = (_borneSup << 8) + 0x000000ff;
					try
					{
						buffer = _entree->lireOctet();
					}
					catch (EFinFichier &)
					{
						buffer  = 0;
					}
					reel = (reel << 8) + buffer;
				}
			}


			// composante 2 (xx5x)
			for (int i = 0; i < 5; ++i)
			{
				pivot = _borneInf + (((_borneSup - _borneInf) >> 12) * P2.p());
				bufferEcriture <<= 1;
				if ( reel <= pivot)
				{
					bufferEcriture += 1;
					P2.apprendre(1);
					_borneSup = pivot;
				}
				else
				{
					P2.apprendre(0);
					_borneInf = pivot + 1;
				}

				while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
				{
					_borneInf <<= 8;
					_borneSup = (_borneSup << 8) + 0x000000ff;
					try
					{
						buffer = _entree->lireOctet();
					}
					catch (EFinFichier &)
					{
						buffer  = 0;
					}
					reel = (reel << 8) + buffer;
				}
			}

			// composante 3 (xxx5)
			for (int i = 0; i < 5; ++i)
			{
				pivot = _borneInf + (((_borneSup - _borneInf) >> 12) * P3.p());
				bufferEcriture <<= 1;
				if ( reel <= pivot)
				{
					bufferEcriture += 1;
					P3.apprendre(1);
					_borneSup = pivot;
				}
				else
				{
					P3.apprendre(0);
					_borneInf = pivot + 1;
				}

				while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
				{
					_borneInf <<= 8;
					_borneSup = (_borneSup << 8) + 0x000000ff;
					try
					{
						buffer = _entree->lireOctet();
					}
					catch (EFinFichier &)
					{
						buffer  = 0;
					}
					reel = (reel << 8) + buffer;
				}
			}

			_sortie->ecrireOctets(&bufferEcriture, sizeof(U16));

			++positionLargeur;
			if ((positionLargeur % largeurImage) == 0)
			{
				for (int i = 0; i < nbZeroAEcrire; ++i)//ecrir le nombre de 0 qui faut pour completer la ligne
				{
					_sortie->ecrireOctet(0);
				}
			}
		}
	}
/////////////////////////////////////////////////////////////////////////

	int ArBMP::nbZero(int nbOctetDansLaLargeur)
	{
		if (!((nbOctetDansLaLargeur + 1) % 4))
		{
			return 1;
		}

		if (!((nbOctetDansLaLargeur + 2) % 4))
		{
			return 2;
		}

		if (!((nbOctetDansLaLargeur + 3) % 4))
		{
			return 3;
		}

		return 0;
	}
}


