/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

/*
** Classe Codeur
**
** 2006-02-10	H2o Classe, prototypes, premire implmentation
**
** TODO : Regarder si il faut mieux utiliser un symbole EOF pour marquer la fin du fichier ou stocker la taille du fichier au debut du fichier
*/



#ifndef ARBMP_H
#define ARBMP_H

#include "../Predicteurs/Ordre1.hpp"
#include"../definitions.hpp"
#include"Codeur.hpp"

namespace BigCrunch
{

	class ArBMP : virtual public Codeur
	{
		public:
			//Constructeur
			ArBMP(const char *nomFichier, ModeCodeur mode);
			ArBMP(const char *nomFichier, ModeCodeur mode, const char *nomSortie);

			//Mthodes
			const char *compresser();
			const char *decompresser();

		protected:
			U32 little2big(U32 n);

		private:
#ifndef SFX
			void ArBMP32Compr(int largeurImage, int hauteurImage);
#endif
			void ArBMP32Decompr(int largeurImage, int hauteurImage);
#ifndef SFX
			void ArBMP24Compr(int largeurImage, int hauteurImage);
#endif
			void ArBMP24Decompr(int largeurImage, int hauteurImage);
#ifndef SFX
			void ArBMP16Compr1555(int largeurImage, int hauteurImage);
#endif
			void ArBMP16Decompr1555(int largeurImage, int hauteurImage);

			int nbZero(int nbOctetDansLaLargeur);

			Ordre1 P0, P1, P2, P3;
			U32 _borneInf,
				_borneSup;

	};

}


#endif
