/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

/*
** Classe Codeur
**
** 2006-02-10	H2o Classe, prototypes, premire implmentation
**
** TODO : Regarder si il faut mieux utiliser un symbole EOF pour marquer la fin du fichier ou stocker la taille du fichier au debut du fichier
*/



#ifndef ARTGA_H
#define ARTGA_H

#include "../Predicteurs/Ordre1.hpp"
#include"../definitions.hpp"
#include"../Structures/Tableau.hpp"
#include"Codeur.hpp"

namespace BigCrunch
{

	class ArTGA : virtual public Codeur
	{
		public:
			//Constructeur
			ArTGA(const char *nomFichier, ModeCodeur mode);
			ArTGA(const char *nomFichier, ModeCodeur mode, const char *nomSortie);

			//Mthodes
#ifndef SFX
			const char *compresser();
#endif
			const char *decompresser();

		private:
#ifndef SFX
			void ArTGA32Compr(int largeurImage, int hauteurImage);
#endif
			void ArTGA32Decompr(int largeurImage, int hauteurImage);
#ifndef SFX
			void ArTGA24Compr(int largeurImage, int hauteurImage);
#endif
			void ArTGA24Decompr(int largeurImage, int hauteurImage);
#ifndef SFX
			void ArTGA16Compr(int largeurImage, int hauteurImage);
#endif
			void ArTGA16Decompr(int largeurImage, int hauteurImage);
#ifndef SFX
			void ArTGAgray16Compr(int largeurImage, int hauteurImage);
#endif
			void ArTGAgray16Decompr(int largeurImage, int hauteurImage);

			void ArTGA24RLECompr(int largeurImage, int hauteurImage);
			void ArTGA24RLEDecompr(int largeurImage, int hauteurImage);
			void Rle24(Tab<U32> &bloc, int largeurImage);

			void ArTGA32RLECompr(int largeurImage, int hauteurImage);
			void ArTGA32RLEDecompr(int largeurImage, int hauteurImage);
			void Rle32(Tab<U32> &bloc, int largeurImage);
			Ordre1 P0, P1, P2, P3;
			U32 _borneInf,
				_borneSup;

	};

}


#endif
