/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

#include"../Outils/Fichier.hpp"

#include"Codeur.hpp"

namespace BigCrunch
{

	// On rgle le mode et on cre les flux d'entre et de sortie
	Codeur::Codeur(const char *nomFichier, ModeCodeur mode)
	{
		_mode = mode;
		_entree = new FluxBinaire(nomFichier, LECTURE);

		_nomSortie = Fichier::NomFichierTemporaire();
		_sortie = new FluxBinaire(_nomSortie, ECRITURE);

		_tailleFichierDepart = _entree->Taille();
		_pasPourcentage = _tailleFichierDepart / 1000;
	}


	Codeur::Codeur(const char *nomFichier, ModeCodeur mode, const char *nomSortie)
	{
		_mode = mode;
		_entree = new FluxBinaire(nomFichier, LECTURE);

		_nomSortie = nomSortie;

		_sortie = new FluxBinaire(_nomSortie, ECRITURE);

		_tailleFichierDepart = _entree->Taille();
		_pasPourcentage = _tailleFichierDepart / 1000;
	}


	// On dtruit les flux
	Codeur::~Codeur()
	{
		delete(_entree);
		delete(_sortie);
	}

	void Codeur::afficherProgression()
	{
		if (((_tailleFichierActuelle = _entree->Position()) % _pasPourcentage) == 0)
		{
			printf("\b\b\b\b\b\b");

			float pourcentage = (float)(_tailleFichierActuelle / (float)_tailleFichierDepart * 100.0);

			if (pourcentage < 10)
			{
				printf("  ");
			}
			else
			{
				if (pourcentage < 100)
				{
					printf(" ");
				}
			}

			printf("%3.1f%%", pourcentage);
		}
	}

}
