/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

/*
** Classe Codeur
**
** 2005-12-26	Arkanosis   Classe, prototypes, premire implmentation
**
** TODO : ---
*/

/*############################*/
#ifndef CODEUR_HPP
#	define CODEUR_HPP
/*############################*/

#include"../definitions.hpp"

#include"../Outils/FluxBinaire.hpp"

namespace BigCrunch
{

	/*
	** Description :
	** 	- Cette enumeration definit si le codeur est utilise pour encoder ou decoder.
	*/

	enum ModeCodeur
	{
		COMPRESSER,
		DECOMPRESSER
	};


	/*
	** Description :
	** 	La classe Codeur ne peut pas etre instancie.
	**	Un codeur prend un fichier en entre et le compresse ou le dcompresse suivant le paramtre mode.
	**
	** Constructeurs :
	** 	- Codeur(char *nomFichier, Mode mode)
	**		Cre un codeur  partir de nomFichier, et selon mode.
	** 	- ~Codeur()
	** 		Detruit le codeur.
	**
	** Mthodes :
	** 	- void preparer()
	** 		Effectue une premire passe sur l'entre pour amliorer la compression.
	** 	- char *compresser()
	** 		Compresse l'entre et retourne le nom du fichier de sortie.
	** 	- char *decompresser()
	** 		Dcompresse l'entre et retourne le nom du fichier de sortie.
	**
	** Proprits :
	*/

	class Codeur
	{
		public:
			// Constructeurs
			Codeur(const char *nomFichier, ModeCodeur mode);
			Codeur(const char *nomFichier, ModeCodeur mode, const char *nomSortie);
			virtual ~Codeur();
			// Mthodes
#ifndef SFX
			virtual const char *compresser() = 0;
#endif
			virtual const char *decompresser() = 0;

			// Proprits

		protected:
			// Mthodes protges
			void afficherProgression();
			// Champs
			ModeCodeur  _mode;
			FluxBinaire *_entree;
			FluxBinaire *_sortie;
			const char  *_nomSortie;
			uint        _tailleFichierDepart;
			uint        _pasPourcentage;
			uint        _tailleFichierActuelle;
	};

}

/*############################*/
#endif
/*############################*/
