/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
**
** TODO gerer les exception de lecture dans les fichier...
** TODO gerer les _bloc supperieurs a 255 motifs (ecrir dans le fichier 2 octets au lieu de 1...)
**		changer les _taille[...] pour qu il puisse recevoir des valeur supperieur a 255...
**		changer les chargement du fichier pour charger des int et non des byte...
**
*/

#include"MTF.hpp"
namespace BigCrunch
{

// Public //
	// Constructeur
	MTF::MTF(const char *nomFichier, ModeCodeur mode) : Codeur(nomFichier, mode)
	{

	}

	MTF::MTF(const char *nomFichier, ModeCodeur mode, const char *nomSortie) : Codeur(nomFichier, mode, nomSortie)
	{

	}
#ifndef SFX

	// Encodeur
	const char *MTF::compresser()
	{
		//creer le tableau index
		_index = new Tab<U8>(256);
		_index->InitEnIncrementant(0);

		Tab<int> *compteur;
		compteur = new Tab<int>(256);
		compteur->Init(0);

        forever
        {
        	//afficherProgression();

			try
			{
				_symbole = _entree->lireOctet();
			}
			catch (EFinFichier &)
			{
				break;
			}

			//mise a jour de l'index
			for (uint i = 0; i < 256; ++i)
			{
				if ((*_index)[i] < (*_index)[_symbole])
				{
					++(*_index)[i];
				}
			}
			//ecrire la position du symbole dans la sortie
			_sortie->ecrireOctet((*_index)[_symbole]);
			//mise au debut du symbole lu
			(*_index)[_symbole] = 0;

			++(*compteur)[_symbole];
        }
        int cmp = 0;
        for (int i = 0; i < 20; ++i)
				cmp += (*compteur)[i];
		//printf ("nbr: %d\n", cmp);
        return _nomSortie;
    }
#endif
	// Decodeur
    const char *MTF::decompresser()
    {
    	uint position = 0;

        //creer le tableau index
		_index = new Tab<U8>(256);
		_index->InitEnIncrementant(0);

        forever
        {
        	//afficherProgression();

			try
			{
				position = _entree->lireOctet();
			}
			catch (EFinFichier &)
			{
				break;
			}

			//recherche du symbole de sortie
			for (uint i = 0; i < 256; ++i)
			{
				if ((*_index)[i] == position)
				{
					_symbole = i;
					break;
				}
			}
			//mise a jour de l'index
			for (uint i = 0; i < 256; ++i)
			{
				if ((*_index)[i] < (*_index)[_symbole])
				{
					++((*_index)[i]);
				}
			}

			//ecrire le symbole dans la sortie
			_sortie->ecrireOctet((U8)(_symbole));
			//mise au debut du symbole decode
			(*_index)[_symbole] = 0;

        }
        return _nomSortie;
    }

// Private //
#ifndef SFX
    //ici ce que l'on a besoin pour la compression
#endif
	//ici ce que l'on a besoin pour la decompression
}

