/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
**
** TODO gerer les exception de lecture dans les fichier...
** TODO gerer les _bloc supperieurs a 255 motifs (ecrir dans le fichier 2 octets au lieu de 1...)
**		changer les _taille[...] pour qu il puisse recevoir des valeur supperieur a 255...
**		changer les chargement du fichier pour charger des int et non des byte...
**
*/

#include"RBMA.hpp"
namespace BigCrunch
{

// Public //
	// Constructeur
	RBMA::RBMA(const char *nomFichier, ModeCodeur mode) : Codeur(nomFichier, mode)
	{

	}

	RBMA::RBMA(const char *nomFichier, ModeCodeur mode, const char *nomSortie) : Codeur(nomFichier, mode, nomSortie)
	{

	}
#ifndef SFX

	// Encodeur
	const char *RBMA::compresser()
	{
		char  *archiveTemp2 = Fichier::NomFichierTemporaire();
		//Rlee  *rle   = NULL;
		Bwoo  *bwt   = NULL;
		MTF   *mtf   = NULL;
		ArSa1 *arith = NULL;

		//rle = new Rlee(_entree->NomFichier(), COMPRESSER, archiveTemp1);
		//rle->compresser();
		//delete rle;
		//printf("Rlee OK\n");

		//char *archiveTemp2 = Fichier::NomFichierTemporaire();

		bwt = new Bwoo(_entree->NomFichier(), COMPRESSER, archiveTemp2, 60000);
		bwt->compresser();
		delete bwt;
		printf("Bwoo OK\n");

		//Fichier::supprimer(archiveTemp1);
		char *archiveTemp1 = Fichier::NomFichierTemporaire();


		mtf = new MTF(archiveTemp2, COMPRESSER, archiveTemp1);
		mtf->compresser();
		delete mtf;
		printf("MTF OK\n");

		Fichier::supprimer(archiveTemp2);

		arith = new ArSa1(archiveTemp1, COMPRESSER, _nomSortie);
		arith->compresser();
		delete arith;
		printf("ArSa1 OK\n");

		Fichier::supprimer(archiveTemp1);

		return _nomSortie;
    }
#endif
	// Decodeur
    const char *RBMA::decompresser()
    {
		char  *archiveTemp1 = Fichier::NomFichierTemporaire();
		Rlee  *rle   = NULL;
		Bwoo  *bwt   = NULL;
		MTF   *mtf   = NULL;
		ArSa1 *arith = NULL;

		arith = new ArSa1(_entree->NomFichier(), DECOMPRESSER, archiveTemp1);
		arith->decompresser();
		delete arith;

		char *archiveTemp2 = Fichier::NomFichierTemporaire();

		mtf = new MTF(archiveTemp1, DECOMPRESSER, archiveTemp2);
		mtf->decompresser();
		delete mtf;

		Fichier::supprimer(archiveTemp1);

		bwt = new Bwoo(archiveTemp2, DECOMPRESSER, archiveTemp1);
		bwt->decompresser();
		delete bwt;

		Fichier::supprimer(archiveTemp2);

		rle = new Rlee(archiveTemp1, DECOMPRESSER, _nomSortie);
		rle->decompresser();
		delete rle;

		Fichier::supprimer(archiveTemp1);

        return _nomSortie;
    }

// Private //
#ifndef SFX
    //ici ce que l'on a besoin pour la compression
#endif
	//ici ce que l'on a besoin pour la decompression
}

