/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

#include"Rlee.hpp"

namespace BigCrunch
{

	//--------------------------------------------------------------------------
	// voila voila... je sais pas quoi dire je suis emu c'est mon premier constructeur.
	Rlee::Rlee(const char *nomFichier, ModeCodeur mode, byte pas, byte limite) : Codeur(nomFichier, mode)
	{
		_pas = pas;
		_limite = limite;
	}

	Rlee::Rlee(const char *nomFichier, ModeCodeur mode, const char *nomSortie, byte pas, byte limite) : Codeur(nomFichier, mode, nomSortie)
	{
		_pas = pas;
		_limite = limite;
	}

    //--------------------------------------------------------------------------
    // Test l'egalite de deux chaines d'octets de meme longueur
    bool Rlee::egalitee(U8 *chaine1, U8 *chaine2, int lg)
    {
        bool res = true;
        int i = 0;

        while (res && (i < lg))
        {
            res = chaine1[i] == chaine2[i];
            ++i;
        }

        return res;
    }

#ifndef SFX
	//--------------------------------------------------------------------------
	// Code le fichier d'entree dans le fichier de sortie en RLEE
	const char *Rlee::compresser()
	{
		unsigned char repet = 1;   // nb de repetitions du motif
		U8 *motif  = NULL;   // section de bits pris comme base pour la comparaison
		U8 *tampon = NULL; // section de bits a comparer au motif

		printf("est ce que motif egale tampon ? reponse : %i\n", (motif == tampon));

		//ecrire le header
		_sortie->ecrireOctet(_pas);
        _sortie->ecrireOctet(_limite);

		// Initialisation du motif
		try
		{
			motif = (U8*) _entree->lireOctets(_pas);
			printf("motif : %c\n", *motif);
		}
		catch (EFinFichier &except)
		{
            printf("Erreur lors de l'intitialisation du motif\n");
			_sortie->ecrireOctets(motif, except.NbOctetsLus());
			printf("nb de bits lus : %i\n\n", except.NbOctetsLus());
			delete motif;
			return _nomSortie;
		}
        printf("Motif initialise\n");

        // Initilisation du tampon
		try
		{
			tampon = (U8*) _entree->lireOctets(_pas);
			printf("tampon : %c\n", *tampon);
		}
		catch (EFinFichier &except)
		{
            printf("Erreur lors de l'intitialisation du tampon\n");
            _sortie->ecrireOctets(motif, _pas);
			_sortie->ecrireOctets(tampon, except.NbOctetsLus());
			delete tampon;
			delete motif;
			return _nomSortie;
		}

		// Encodage
		forever
		{
			// On compte les repetitions
			repet = 1;

			while (egalitee(motif, tampon, _pas))
			{
				++repet;
				// Pas suivant
				try
				{
					tampon = (U8 *) _entree->lireOctets(_pas);
				}
				catch (EFinFichier &except) // On a atteint la fin du fichier en cherchant les repetitions
				{
                    printf("Erreur lors de la lecture du tampon\n");
                    _sortie->ecrireOctet(repet);
                    _sortie->ecrireOctets(motif, _pas);
                    _sortie->ecrireOctets(tampon, except.NbOctetsLus());

					// Et on nettoie
                    delete tampon;
                    delete motif;
                    return _nomSortie;
				}
			}

			// On ecrit dans le fichier
			_sortie->ecrireOctet(repet);
			_sortie->ecrireOctets(motif, _pas);

            // Et c'est reparti
            motif = tampon;  // Car il est alors different
            try
            {
                tampon = (U8 *) _entree->lireOctets(_pas);
            }
            catch (EFinFichier &)  // Le fichier fait pile poil un mutltiple du pas !!
            {
                _sortie->ecrireOctet(1);
                _sortie->ecrireOctets(motif, _pas);
                break;
            }
		}


		delete tampon;
		delete motif;
		return _nomSortie;
	}
#endif


	//--------------------------------------------------------------------------
	// Recupere le header en vue d'une decompression
	bool Rlee::recupHeader()
	{
		try
		{
			_pas = _entree->lireOctet();                                        // Le pas tjrs en 2e octet
			_limite = _entree->lireOctet();                                     // La limite tjrs en derniere
			//printf("header lut\n");
			//printf("pas : %i\n", _pas);
			//printf("limite : %i\n", _limite);
			return true;
		}
		catch (EFinFichier &)
		{
			return false;
		}
	}

	//--------------------------------------------------------------------------
	// Decode le fichier compresse en RLEE
	const char *Rlee::decompresser()
	{
		int i;
		int repet = 0;                                                          // nb de repettitions
		U8 *motif = new U8;                                                     // motif repete

		//printf("DECOMPRESSION\n");
		if (recupHeader())
		{
			forever
			{
				try
				{
					repet = _entree->lireOctet();
					motif = (U8 *) _entree->lireOctets(_pas);
			//		printf("repet : %c\n", repet);
				//	printf("motif : %c\n", *motif);
				}
				catch (EFinFichier &except)
				{
                    _sortie->ecrireOctets(motif, except.NbOctetsLus());        // Le fichier est finit mais sur une donne qui tait incomplette lors de la compression on ecrit donc en vrac
                    delete motif;
					return _nomSortie;
				}

				for (i = 1; i <= repet; ++i)
				{
					_sortie->ecrireOctets(motif, _pas);                         // Ecriture des donnees decompressees
				}
			}
		}
		else
		{
		    //printf("Fichier incorrect");
		    delete motif;
			return NULL;                                                        // Fichier corrompu
		}
	}



}
