/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

/*
** Classe Rlee
**
** 2005-12-26	Arkanosis   Classe, prototypes, premire implmentation
**
** TODO : <TODO>
*/

/*############################*/
#ifndef RLEE_HPP
#	define RLEE_HPP
/*############################*/

#include"../definitions.hpp"

#include"Codeur.hpp"

namespace BigCrunch
{

	/*
	** Description :
	** 	<Description>.
	**
	** Constructeurs :
	** 	- Rlee(char *nomFichier, ModeCodeur mode)
	** 		<Explications>
	** 	- ~Rlee()
	** 		Dtruit <NomClasse>
	**	- preparer()
	**		calcul le pas et la limite puis les metes dans le header
	**	- recupHeader()
	**		recupere le header en vue d'une decompression
	**	- compresser()
	**		code le fichier d'entree en rlee
	**	- decompresser()
	**		decode le fichier d'entree code en rlee
	**
	** Mthodes :
	**
	** Proprits :
	*/

	class Rlee : virtual public Codeur
	{
		public:
			// Constructeurs
			Rlee(const char *nomFichier, ModeCodeur mode, byte pas = 1, byte limite = 128);
			Rlee(const char *nomFichier, ModeCodeur mode, const char *nomSortie, byte pas = 1, byte limite = 128);
//			~Rlee();
			// Mthodes
#ifndef SFX
			const char *compresser();
#endif
			const char *decompresser();
			// Proprits

		protected:
            // Mthodes protges
			bool egalitee(U8 *chaine1, U8 *chaine2, int lg);
			bool recupHeader();
			// Champs
			byte _limite;
			byte _pas;
	};

}

/*############################*/
#endif
/*############################*/
