/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Version ligne de commande
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

/*############################*/
#ifndef PARAMETRE_COMMANDE_HPP
#	define PARAMETRE_COMMANDE_HPP
/*############################*/

#include"../definitions.hpp"

#include"Typage.hpp"


namespace BigCrunch
{

	enum Action
	{
		AUCUNE,
		AJOUTER,
		EXTRAIRE,
		SUPPRIMER,
		LISTER,
		TESTER,
		CONVERTIR
	};


	enum Reaction
	{
		PASSER,
		RENOMMER,
		ECRASER
	};


	enum Algorithme
	{
		AUCUN = 255,
		TAR0 = 0,
		RLEE = 1,
		SAHUFFMAN = 11,
		LZR = 21,
		LZH = 22,
		BWOO = 61,
		BRH = 62,
		Ari = 81
	};

	enum Sfx
	{
		NON = 0,
		WIN = 1,
		LINUX = 11,
		BSD = 21,
		MACOS = 31
	};


	struct ParametresCommande
	{
		// Constructeur
		ParametresCommande();

		// Destructeur
		~ParametresCommande();

		// Champs publics
		Action   action ;
		string   nomSortie;
		bool     miseAJour;
		int      tailleVolumes;
		Sfx      plateForme;
		byte     mode;
		bool     optimiser;
		bool     forcer;
		byte     details;
		bool     logger;
		string   log;
		FILE     *logf;
		bool     cloche;
		bool     effacer;
		Reaction reaction;
		Typage   *fichiers;

		queue<string> tabTypes[NB_TYPES];
	};

}

/*############################*/
#endif
/*############################*/
