/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

/*
** Classe Parseur
**
** 2005-11-28	Arkanosis   Classe, prototypes, premire implmentation
**
** TODO : Utiliser des files plutot que des listes chaines pour avoir les fichiers dans l'ordre
*/

/*############################*/
#ifndef PARSEUR_HPP
#	define PARSEUR_HPP
/*############################*/

#include"../definitions.hpp"

#include"../Outils/Fichier.hpp"

#include"./Typage.hpp"
#include"ParametresCommande.hpp"

namespace BigCrunch
{

	class ESansArgument
	{
	};

	class Parseur
	{
		public:
			// Constructeurs
			// Mthodes
			static bool parser(int nbMots, char *commande[], ParametresCommande &parametres);
			// Proprits

		protected:
			// Mthodes
#ifndef SFX
			static void parserOption(char *option, ParametresCommande &parametres, bool &erreur, bool &parseOptions);
			static void parserSfx(char *sfx, ParametresCommande &parametres, bool &erreur);
			static void parserSortie(char *fichier, ParametresCommande &parametres, bool &erreur);
#endif
			static void parserFichier(char *fichier, ParametresCommande &parametres, bool &erreur);
#ifndef SFX
			static void parserVolumes(char *taille, ParametresCommande &parametres, bool &erreur);
			static void parserMode(char *mode, ParametresCommande &parametres, bool &erreur);
			static void parserDetails(char *details, ParametresCommande &parametres, bool &erreur);
			static void parserLog(char *log, ParametresCommande &parametres, bool &erreur);
			static void parserReaction(char *reaction, ParametresCommande &parametres, bool &erreur);
			static bool estSwitch(char caractere);
			static bool estEchappement(char caractere);
			static bool installer(int nbMots, char *commande[]);
			static bool desinstaller();
#endif
	};

}

/*############################*/
#endif
/*############################*/
