/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

#include"Typage.hpp"

namespace BigCrunch
{
    // Constructeur
    Typage::Typage(queue<string> *tabTypes)
    {
		_tabTypes = tabTypes;
		_nbFichiers = 0;
    }

	// Assignement d'une extension a son code ascii non-imprimable
	RefTypes Typage::getCodeExt(string in_ext)
	{
		const char *ext = in_ext.c_str();

//		printf("Debut Fonction getCodeExt\n");
//		printf("Variable : ext = %s\n", ext);
		// Les fichiers textuels
		if (!strcmp(ext, ".txt"))
			return TXT;


		if (!strcmp(ext, ".doc"))
			return TXT;

		// Les images
		if (!strcmp(ext, ".tga"))
			return TGA;

		if (!strcmp(ext, ".bmp"))
			return BMP;

		// Les executables
		if (!strcmp(ext, ".exe"))
			return EXE;

		// Les Incompressibles
		if (!strcmp(ext, ".jpeg"))
			return INC;

		if (!strcmp(ext, ".gzip"))
			return INC;

		if (!strcmp(ext, ".tgz"))
			return INC;

		// Le fichier inconnu (c'est comme le soldat mais version geek)
		return UKN;

	}


    // Ajoute un fichier a _refTab
    void Typage::AddFile(string fichier)
    {
    	int i = 0;                                                              // Variable de parcours
    	int ind = 0;                                                            // indice du dernier point
    	int lg = 0;                                                             // longueur de la chaine
		string ext;                                                             // l'extension du fichier

    	while (fichier[i] != '\0')
    	{
    		if (fichier[i] == '.')
    			ind = i;
			++i;
    	}

    	lg = i;
		if ((ind == lg) || (ind == 0))                                          // Fichier sans extension
		{
			_tabTypes[UKN].push(fichier);
		}
		else
		{
			ext = &fichier[ind];
			_tabTypes[getCodeExt(ext)].push(fichier);
		}
		++_nbFichiers;
    }

	void Typage::AddForce(string fichier)
    {
		_tabTypes[0].push(fichier);
		++_nbFichiers;
    }


	// teste si le tableau de files est vide
	bool Typage::EstVide()
	{
		if (_nbFichiers == 0)
			return true;
		else
			return false;
	}


	// renvoit le nombre d'elements contenues dans toutes les files
	uint Typage::NbFichiers()
	{
		return _nbFichiers;
	}


	// Affiche le contenu des files dans l'ordre
	void Typage::Affiche()
	{
		int i = 0;

		for (i = 0 ; i < NB_TYPES ; ++i)
		{
			while (!_tabTypes[i].empty())
			{
				const char *tmp = (_tabTypes[i].front()).c_str();
				printf("file %i elt %s\n", i, tmp);
				_tabTypes[i].pop();
			}
		}
	}


	bool Typage::contientEtSupprime(string fichier)
	{
		if (!_tabTypes[0].empty())
		{
			string premier = _tabTypes[0].front();
			bool existe  = (premier == fichier);
			_tabTypes[0].pop();
			if (!existe)
			{
				_tabTypes[0].push(premier);
			}
	
			while (!existe && (premier != _tabTypes[0].front()))
			{
				existe  = (_tabTypes[0].front() == fichier);
				if (!existe)
				{
					_tabTypes[0].push(_tabTypes[0].front());
				}
				_tabTypes[0].pop();
	
	
	
	
	
	
	
	
	
	
	
			}
	
			return existe;
		}
		
		return false;
	}


}
