/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

/*
** Classe Parseur
**
** 2005-11-28	Arkanosis   Classe, prototypes, premire implmentation
**
** TODO : Utiliser des files plutot que des listes chaines pour avoir les fichiers dans l'ordre
*/

/*############################*/
#ifndef TYPAGE_HPP
#	define TYPAGE_HPP
/*############################*/

#include"../definitions.hpp"
//#include"../Outils/ParcDossier.hpp"

namespace BigCrunch
{

	/*
	** Description :
	** 	La classe Typage permet de classer les fichiers passes en parametre dans
	**	la ligne de commande parsee selon leur types dans un tableau de file
	**	dont les indices sont propres a un type de fichier.
	**
	** Constructeurs :
	** 	- Typage();
	**		Initialise le le champ contenant le tableau _tabTypes qui contiendra
	**		les noms des fichiers classes selon leurs types
	**
	** 	- ~Typage();
	** 		Detruit proprement le champ _tabTypes
	**
	** Mthodes :
	** 	- char getCodeExt(string ext)
	** 		Retourne le code assigne au type d'un fichier selon son extension
	**		Passee en parametre.
	**
	** Proprits :
	**	- void AddFile(string fichier)
	**		Ajoute un nom de fichier au champ tabTypes, a sa place.
	**
		- void Affiche()
			Simple procedure de test qui affiche le contenu de tabTypes.
	*/

//------------------------------------------------------------------------------

	// Enumeration qui simplifie l'ordinance des types de fichiers dans le
	// champ tabTypes.
	//

#define NB_TYPES (INC + 1)

    enum RefTypes
    {
    	ID,     // Fichier identique au suivant
        TXT,    // Fichiers textes
        EXE,    // Executables
        UKN,    // Types inconnus
		BMP,    // Images BMP
		TGA,    // Images TGA

		// Types Incompressibles (doit absolument rester le dernier !!!)
        INC
    };



	class Typage
	{
	    public :
            // Constructeur
            Typage(queue<string> *tabTypes);									// Il est deja alloue

            // Methodes
			bool           contientEtSupprime(string fichier);
			void 		   AddFile(string fichier);
			void 		   AddForce(string fichier);

            // Proprietes
            bool 		   EstVide();
            uint           NbFichiers();

        protected :
            // Methodes
			RefTypes       getCodeExt(string ext);

            // Proprietes
			void           Affiche();

            // Champs
			queue<string> *_tabTypes;											// pointeur vers un tableau de files contenants des chaines
			uint          _nbFichiers;
	};

}
/*############################*/
#endif
/*############################*/
