/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Version ligne de commande
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

#include"../definitions.hpp"

#include"Commande.hpp"
#include"../Outils/FluxBinaire.hpp"

// TODO eric #include"../Outils/Dossier.hpp"


using namespace BigCrunch;


int mainFr(int argc, char *argv[], bool installe)
{
	printf("\n\n+------------------------------------------------------------------------------+\n");
	printf("|Big Crunch " VERSION_BCRUNCH_TXT " (" __DATE__ ") - Copyright (C) 2005-2006 - KaBoom       |\n");
	printf("|                                                                              |\n");
	printf("|Compresseur gratuit et open-source hautes performances                       |\n");
	printf("+------------------------------------------------------------------------------+\n");

	try
	{
		Commande::executer(argc, argv);

		printf("+------------------------------------------------------------------------------+\n");
	}
	catch (ESansArgument &)
	{
		printf("Usage : " NOM_EXE " <a|x|r|l|c|t> [-<o|u><archive[.bc]>] [-cX]\n");
		printf("        [-s<w|l|b|m>] [-m<0..3|x>] [-a] [-k] [-<v|q||d<0..6>>]\n");
		printf("        [-l<archive[.log]>] [-b] [-e] [-x<0..2>] fichier1[fichier2[...]]\n");

		printf("\n");

		printf("Commandes\n");
		printf("\ta : ajouter a l'archive\n");
		printf("\tx : extraire de l'archive\n");
		printf("\tr : supprimer de l'archive\n");
		printf("\tl : lister les fichiers de l'archive\n");

		printf("\tc : convertir l'archive\n");
		printf("\tt : tester l'archive\n");
#ifdef DEBUG
		printf("\t-\n");

		if (installe)
		{
			printf("\tu : desinstaller Big Crunch\n");
		}
		else
		{
			printf("\tinstall [-<fr|en|de>] : installer Big Crunch\n");
			printf("\t(fr : francais, en : anglais, de : allemand)\n");
		}
#endif

		printf("\n");

		printf("Options\n");
		printf("\t-o<archive[.bc]>  : ecrire dans l'archive\n");
		printf("\t-u<archive[.bc]>  : mettre a jour l'archive\n");
		printf("\t-cX : decouper en volumes de X kio au plus\n");
		printf("\t-sX : creer une archive autoextractible pour la plate-forme X\n");
		printf("\t-mX : utiliser le mode X\n");
		printf("\t-a  : rechercher les doublons\n");
		printf("\t-k  : forcer la compression (malgre les erreurs)\n");
		printf("\t-v  : afficher les details (alias de -d%i)\n", DETAILS_VERBOSE);
		printf("\t-q  : masquer les details (alias de -d%i)\n", DETAILS_QUIET);
		printf("\t-dX : niveau X de details\n");
		printf("\t-l<archive[.log]> : ecrire les logs\n");
		printf("\t-b  : jouer un son a la fin de l'operation\n");
		printf("\t-e  : supprimer les fichiers apres ajout dans l'archive\n");
		printf("\t-xX : effectuer l'action X lorsqu'un fichier existe deja\n");

		printf("\n");

		printf("Plates-formes (x86 uniquement)\n");

		printf("\tw : Win32\n");
		printf("\tl : Linux\n");
		printf("\tb : BSD\n");
		printf("\tm : MacOs\n");

		printf("\n");

		printf("Modes\n");

#if MODE_PAR_DEFAUT == 0
		printf("\t0 : pas de compression (par defaut)\n");
#else
		printf("\t0 : pas de compression\n");
#endif
#if MODE_PAR_DEFAUT == 1
		printf("\t1 : compression rapide (par defaut)\n");
#else
		printf("\t1 : compression rapide\n");
#endif
#if MODE_PAR_DEFAUT == 2
		printf("\t2 : compression normale (par defaut)\n");
#else
		printf("\t2 : compression normale\n");
#endif
#if MODE_PAR_DEFAUT == 3
		printf("\t3 : bonne compression (par defaut)\n");
#else
		printf("\t3 : bonne compression\n");
#endif
#if MODE_PAR_DEFAUT == 4
		printf("\tx : meilleure compression (lent) (par defaut)\n");
#else
		printf("\tx : meilleure compression (lent)\n");
#endif

		printf("\n");

		printf("Niveaux de details\n");

#if DETAILS_PAR_DEFAUT == 0
		printf("\t0 : pas de details (par defaut)\n");
#else
		printf("\t0 : pas de details\n");
#endif
#if DETAILS_PAR_DEFAUT == 1
		printf("\t1 : affichage de la progression (par defaut)\n");
#else
		printf("\t1 : affichage de la progression\n");
#endif
#if DETAILS_PAR_DEFAUT == 2
		printf("\t2 : -d1 + recapitulatif final (par defaut)\n");
#else
		printf("\t2 : -d1 + recapitulatif final\n");
#endif
#if DETAILS_PAR_DEFAUT == 3
		printf("\t3 : -d2 + recapitulatifs intermediaires (par defaut)\n");
#else
		printf("\t3 : -d2 + recapitulatifs intermediaires\n");
#endif
#if DETAILS_PAR_DEFAUT == 4
		printf("\t4 : -d3 + pourcentage d'avancement (par defaut)\n");
#else
		printf("\t4 : -d3 + pourcentage d'avancement\n");
#endif
#if DETAILS_PAR_DEFAUT == 5
		printf("\t5 : -d4 + details avances (par defaut)\n");
#else
		printf("\t5 : -d4 + details avances\n");
#endif
#if DETAILS_PAR_DEFAUT == 6
		printf("\t6 : -d5 + details developpeur (par defaut)\n");
#else
		printf("\t6 : -d5 + details developpeur\n");
#endif

		printf("\n");

		printf("Actions\n");

#if REACTION_PAR_DEFAUT == 0
		printf("\t0 : Ne pas extraire (par defaut)\n");
#else
		printf("\t0 : Ne pas extraire\n");
#endif
#if REACTION_PAR_DEFAUT == 1
		printf("\t1 : Renommer (par defaut)\n");
#else
		printf("\t1 : Renommer\n");
#endif
#if REACTION_PAR_DEFAUT == 2
		printf("\t2 : Ecraser (par defaut)\n");
#else
		printf("\t2 : Ecraser\n");
#endif

		printf("\n");

		printf("Exemples\n");

		printf("\t" NOM_EXE " a cv.doc\n");
		printf("\t\tajoute \"cv.doc\" a \"archive.bc\"\n");
		printf("\t" NOM_EXE " a \"ancien cv.doc\" cv.doc -m3 -q -ocv.bc\n");
		printf("\t\tajoute \"ancien cv.doc\" et \"cv.doc\" a \"cv.bc\" avec une bonne\n");
		printf("\t\tcompression, sans afficher de details\n");
		printf("\t" NOM_EXE " a programmes cv.doc -mx -a -v -sw -r -osetup.exe\n");
		printf("\t\tajoute le contenu du dossier \"programmes\" a l'autoextractible\n");
		printf("\t\tpour Windows \"setup.exe\" avec une meilleure compression,\n");
		printf("\t\tune recherche de doublons, en affichant des details\n");
		printf("\t" NOM_EXE " x cv.bc\n");
		printf("\t\textrait le contenu de l'archive \"cv.bc\"\n");

		printf("\n");

		printf("\n-------------------------------------------------------------------------------\n");
	}
	catch (...)
	{
		// LOG exception dclenche quelque part
		printf("Execution terminee avec une exception");

		return EXIT_FAILURE;
	}

	return EXIT_SUCCESS;
}

int mainEn(int argc, char *argv[], bool installe)
{
	printf("\n\n+------------------------------------------------------------------------------+\n");
	printf("|Big Crunch " VERSION_BCRUNCH_TXT " (" __DATE__ ") - Copyright (C) 2005-2006 - KaBoom       |\n");
	printf("|                                                                              |\n");
	printf("|High performances freeware and open-source compressor                       |\n");
	printf("+------------------------------------------------------------------------------+\n");

	try
	{
		Commande::executer(argc, argv);

		printf("+------------------------------------------------------------------------------+\n");
	}
	catch (ESansArgument &)
	{
		printf("Usage : " NOM_EXE " <a|x|r|l|c|t> [-<o|u><archive[.bc]>] [-cX]\n");
		printf("        [-s<w|l|b|m>] [-m<0..3|x>] [-a] [-k] [-<v|q||d<0..6>>]\n");
		printf("        [-l<archive[.log]>] [-b] [-e] [-x<0..2>] fichier1[fichier2[...]]\n");

		printf("\n");

		printf("Commands\n");
		printf("\ta : add to archive\n");
		printf("\tx : extract from archive\n");
		printf("\tr : remove from archive\n");
		printf("\tl : list files in archive\n");

		printf("\tc : convert archive\n");
		printf("\tt : test archive\n");
#ifdef DEBUG
		printf("\t-\n");

		if (installe)
		{
			printf("\tu : uninstall Big Crunch\n");
		}
		else
		{
			printf("\ti [-<fr|en|de>] : install Big Crunch\n");
			printf("\t(fr : French, en : English, de : German)\n");
		}
#endif

		printf("\n");

		printf("Options\n");
		printf("\t-o<archive[.bc]>  : write into archive\n");
		printf("\t-u<archive[.bc]>  : update archive\n");
		printf("\t-cX : split in volumes of X kio at most\n");
		printf("\t-sX : create a self-extractible archive for the X platform\n");
		printf("\t-mX : use the X mode\n");
		printf("\t-a  : look for duplicates\n");
		printf("\t-k  : force compression (despite errors)\n");
		printf("\t-v  : show details (alias of -d%i)\n", DETAILS_VERBOSE);
		printf("\t-q  : hide details (alias of -d%i)\n", DETAILS_QUIET);
		printf("\t-dX : X level of details\n");
		printf("\t-l<archive[.log]> : write logs\n");
		printf("\t-b  : play sound after process\n");
		printf("\t-e  : delete files after adding to archive\n");
		printf("\t-xX : do action X when files already exist\n");

		printf("\n");

		printf("Platforms (x86 only)\n");

		printf("\tw : Win32\n");
		printf("\tl : Linux\n");
		printf("\tb : BSD\n");
		printf("\tm : MacOs\n");

		printf("\n");

		printf("Modes\n");

#if MODE_PAR_DEFAUT == 0
		printf("\t0 : no compression (default)\n");
#else
		printf("\t0 : no compression\n");
#endif
#if MODE_PAR_DEFAUT == 1
		printf("\t1 : fast compression (default)\n");
#else
		printf("\t1 : fast compression\n");
#endif
#if MODE_PAR_DEFAUT == 2
		printf("\t2 : normal compression (default)\n");
#else
		printf("\t2 : normal compression\n");
#endif
#if MODE_PAR_DEFAUT == 3
		printf("\t3 : good compression (default)\n");
#else
		printf("\t3 : good compression\n");
#endif
#if MODE_PAR_DEFAUT == 4
		printf("\tx : best compression (slow) (default)\n");
#else
		printf("\tx : best compression (slow)\n");
#endif

		printf("\n");

		printf("Levels of details\n");

#if DETAILS_PAR_DEFAUT == 0
		printf("\t0 : no details (default)\n");
#else
		printf("\t0 : no details\n");
#endif
#if DETAILS_PAR_DEFAUT == 1
		printf("\t1 : show progression (default)\n");
#else
		printf("\t1 : show progression\n");
#endif
#if DETAILS_PAR_DEFAUT == 2
		printf("\t2 : -d1 + final report (default)\n");
#else
		printf("\t2 : -d1 + final report\n");
#endif
#if DETAILS_PAR_DEFAUT == 3
		printf("\t3 : -d2 + intermediate reports (default)\n");
#else
		printf("\t3 : -d2 + intermediate reports \n");
#endif
#if DETAILS_PAR_DEFAUT == 4
		printf("\t4 : -d3 + running percentage (default)\n");
#else
		printf("\t4 : -d3 + running percentage\n");
#endif
#if DETAILS_PAR_DEFAUT == 5
		printf("\t5 : -d4 + advanced details (default)\n");
#else
		printf("\t5 : -d4 + advanced details \n");
#endif
#if DETAILS_PAR_DEFAUT == 6
		printf("\t6 : -d5 + developer details (default)\n");
#else
		printf("\t6 : -d5 + developer details \n");
#endif

		printf("\n");

		printf("Actions\n");

#if REACTION_PAR_DEFAUT == 0
		printf("\t0 : do not extract (default)\n");
#else
		printf("\t0 : do not extract\n");
#endif
#if REACTION_PAR_DEFAUT == 1
		printf("\t1 : rename (default)\n");
#else
		printf("\t1 : rename\n");
#endif
#if REACTION_PAR_DEFAUT == 2
		printf("\t2 : overwrite (default)\n");
#else
		printf("\t2 : overwrite\n");
#endif

		printf("\n");

		printf("Examples\n");

		printf("\t" NOM_EXE " a cv.doc\n");
		printf("\t\tadds \"cv.doc\" to \"archive.bc\"\n");
		printf("\t" NOM_EXE " a \"old cv.doc\" cv.doc -m3 -q -ocv.bc\n");
		printf("\t\tadds \"old cv.doc\" and \"cv.doc\" to \"cv.bc\" with a good\n");
		printf("\t\tcompression, without showing any detail\n");
		printf("\t" NOM_EXE " a programs cv.doc -mx -a -v -sw -r -osetup.exe\n");
		printf("\t\tadds the content of the \"programs\" directory to the self-\n");
		printf("\t\textractible Windows archive \"setup.exe\" with the best\n");
		printf("\t\tcompression, a duplicates lookup, showing details\n");
		printf("\t" NOM_EXE " x cv.bc\n");
		printf("\t\textracts the content of the \"cv.bc\" archive\n");

		printf("\n");

		printf("\n-------------------------------------------------------------------------------\n");
	}
	catch (...)
	{
		// LOG exception dclenche quelque part
		printf("Execution terminee avec une exception");

		return EXIT_FAILURE;
	}

	return EXIT_SUCCESS;
}

int mainDe(int argc, char *argv[], bool installe)
{
	printf("\n\n+------------------------------------------------------------------------------+\n");
	printf("|Big Crunch " VERSION_BCRUNCH_TXT " (" __DATE__ ") - Copyright (C) 2005-2006 - KaBoom       |\n");
	printf("|                                                                              |\n");
	printf("|Compresseur gratuit et open-source hautes performances                       |\n");
	printf("+------------------------------------------------------------------------------+\n");

	try
	{
		Commande::executer(argc, argv);

		printf("+------------------------------------------------------------------------------+\n");
	}
	catch (ESansArgument &)
	{
		printf("Usage : " NOM_EXE " <a|x|r|l|c|t> [-<o|u><archive[.bc]>] [-cX]\n");
		printf("        [-s<w|l|b|m>] [-m<0..3|x>] [-a] [-k] [-<v|q||d<0..6>>]\n");
		printf("        [-l<archive[.log]>] [-b] [-e] [-x<0..2>] fichier1[fichier2[...]]\n");

		printf("\n");

		printf("Commandes\n");
		printf("\ta : ajouter a l'archive\n");
		printf("\tx : extraire de l'archive\n");
		printf("\tr : supprimer de l'archive\n");
		printf("\tl : lister les fichiers de l'archive\n");

		printf("\tc : convertir l'archive\n");
		printf("\tt : tester l'archive\n");
#ifdef DEBUG
		printf("\t-\n");

		if (installe)
		{
			printf("\tu : desinstaller Big Crunch\n");
		}
		else
		{
			printf("\tinstall [-<fr|en|de>] : installer Big Crunch\n");
			printf("\t(fr : francais, en : anglais, de : allemand)\n");
		}
#endif

		printf("\n");

		printf("Options\n");
		printf("\t-o<archive[.bc]>  : ecrire dans l'archive\n");
		printf("\t-u<archive[.bc]>  : mettre a jour l'archive\n");
		printf("\t-cX : decouper en volumes de X kio au plus\n");
		printf("\t-sX : creer une archive autoextractible pour la plate-forme X\n");
		printf("\t-mX : utiliser le mode X\n");
		printf("\t-a  : rechercher les doublons\n");
		printf("\t-k  : forcer la compression (malgre les erreurs)\n");
		printf("\t-v  : afficher les details (alias de -d%i)\n", DETAILS_VERBOSE);
		printf("\t-q  : masquer les details (alias de -d%i)\n", DETAILS_QUIET);
		printf("\t-dX : niveau X de details\n");
		printf("\t-l<archive[.log]> : ecrire les logs\n");
		printf("\t-b  : jouer un son a la fin de l'operation\n");
		printf("\t-e  : supprimer les fichiers apres ajout dans l'archive\n");
		printf("\t-xX : effectuer l'action X lorsqu'un fichier existe deja\n");

		printf("\n");

		printf("Plates-formes (x86 uniquement)\n");

		printf("\tw : Win32\n");
		printf("\tl : Linux\n");
		printf("\tb : BSD\n");
		printf("\tm : MacOs\n");

		printf("\n");

		printf("Modes\n");

#if MODE_PAR_DEFAUT == 0
		printf("\t0 : pas de compression (par defaut)\n");
#else
		printf("\t0 : pas de compression\n");
#endif
#if MODE_PAR_DEFAUT == 1
		printf("\t1 : compression rapide (par defaut)\n");
#else
		printf("\t1 : compression rapide\n");
#endif
#if MODE_PAR_DEFAUT == 2
		printf("\t2 : compression normale (par defaut)\n");
#else
		printf("\t2 : compression normale\n");
#endif
#if MODE_PAR_DEFAUT == 3
		printf("\t3 : bonne compression (par defaut)\n");
#else
		printf("\t3 : bonne compression\n");
#endif
#if MODE_PAR_DEFAUT == 4
		printf("\tx : meilleure compression (lent) (par defaut)\n");
#else
		printf("\tx : meilleure compression (lent)\n");
#endif

		printf("\n");

		printf("Niveaux de details\n");

#if DETAILS_PAR_DEFAUT == 0
		printf("\t0 : pas de details (par defaut)\n");
#else
		printf("\t0 : pas de details\n");
#endif
#if DETAILS_PAR_DEFAUT == 1
		printf("\t1 : affichage de la progression (par defaut)\n");
#else
		printf("\t1 : affichage de la progression\n");
#endif
#if DETAILS_PAR_DEFAUT == 2
		printf("\t2 : -d1 + recapitulatif final (par defaut)\n");
#else
		printf("\t2 : -d1 + recapitulatif final\n");
#endif
#if DETAILS_PAR_DEFAUT == 3
		printf("\t3 : -d2 + recapitulatifs intermediaires (par defaut)\n");
#else
		printf("\t3 : -d2 + recapitulatifs intermediaires\n");
#endif
#if DETAILS_PAR_DEFAUT == 4
		printf("\t4 : -d3 + pourcentage d'avancement (par defaut)\n");
#else
		printf("\t4 : -d3 + pourcentage d'avancement\n");
#endif
#if DETAILS_PAR_DEFAUT == 5
		printf("\t5 : -d4 + details avances (par defaut)\n");
#else
		printf("\t5 : -d4 + details avances\n");
#endif
#if DETAILS_PAR_DEFAUT == 6
		printf("\t6 : -d5 + details developpeur (par defaut)\n");
#else
		printf("\t6 : -d5 + details developpeur\n");
#endif

		printf("\n");

		printf("Actions\n");

#if REACTION_PAR_DEFAUT == 0
		printf("\t0 : Ne pas extraire (par defaut)\n");
#else
		printf("\t0 : Ne pas extraire\n");
#endif
#if REACTION_PAR_DEFAUT == 1
		printf("\t1 : Renommer (par defaut)\n");
#else
		printf("\t1 : Renommer\n");
#endif
#if REACTION_PAR_DEFAUT == 2
		printf("\t2 : Ecraser (par defaut)\n");
#else
		printf("\t2 : Ecraser\n");
#endif

		printf("\n");

		printf("Exemples\n");

		printf("\t" NOM_EXE " a cv.doc\n");
		printf("\t\tajoute \"cv.doc\" a \"archive.bc\"\n");
		printf("\t" NOM_EXE " a \"ancien cv.doc\" cv.doc -m3 -q -ocv.bc\n");
		printf("\t\tajoute \"ancien cv.doc\" et \"cv.doc\" a \"cv.bc\" avec une bonne\n");
		printf("\t\tcompression, sans afficher de details\n");
		printf("\t" NOM_EXE " a programmes cv.doc -mx -a -v -sw -r -osetup.exe\n");
		printf("\t\tajoute le contenu du dossier \"programmes\" a l'autoextractible\n");
		printf("\t\tpour Windows \"setup.exe\" avec une meilleure compression,\n");
		printf("\t\tune recherche de doublons, en affichant des details\n");
		printf("\t" NOM_EXE " x cv.bc\n");
		printf("\t\textrait le contenu de l'archive \"cv.bc\"\n");

		printf("\n");

		printf("\n-------------------------------------------------------------------------------\n");
	}
	catch (...)
	{
		// LOG exception dclenche quelque part
		printf("Les parametres passes en ligne de commande sont incorrects");

		return EXIT_FAILURE;
	}

	return EXIT_SUCCESS;
}

//#include"../Codeurs/RBMA.hpp"
//#define CMP

int main(int argc, char *argv[])
{
	/*#ifdef CMP
	RBMA codeur("test.txt", COMPRESSER, "RBMA.tmp");
	codeur.compresser();
	#else
	RBMA codeur("RBMA.tmp", DECOMPRESSER, "RBMA.txt");
	codeur.decompresser();
	#endif*/

	// Dfinitions des super-globales du programme
	bool BCRUNCH_INSTALLE = false;
	Langue BCRUNCH_LANGUE = EN;

	switch (BCRUNCH_LANGUE)
	{
		case FR:
			return mainFr(argc, argv, BCRUNCH_INSTALLE);
		case EN:
			return mainEn(argc, argv, BCRUNCH_INSTALLE);
		case DE:
			return mainDe(argc, argv, BCRUNCH_INSTALLE);
	}


}
