/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

#include"Speed2Mix.hpp"
#include<cmath>




namespace BigCrunch
{

#define w0 48
void SpeedMix::apprendre(U8 bit)
	{
		double Somme_b = 0;
		double Somme = 0;

		//mise a jours des freq pour le calcule des probabilite
		++_Stat1[_ctxIn][bit];
		++_NonStat1[_ctxIn][bit];
		++_SemiStat1[_ctxIn][bit];
		++_SemiStat2[_hash1][bit];
		++_SemiStat5[_hash2][bit];

		//mise a jours des modeles (non lineaire et semi-lineaire)
		if (bit == 1)
		{
			_NonStat1[_ctxIn][0] = 0;
			if (_SemiStat1[_ctxIn][0] > 2 )
			{
				_SemiStat1[_ctxIn][0] = (U16) floor(_SemiStat1[_ctxIn][0] / 2.0 + 1);
			};
			if (_SemiStat2[_hash1][0] > 2)
			{
				_SemiStat2[_hash1][0] = (U16) floor(_SemiStat2[_hash1][0] / 2.0 + 1);
			};
			if (_SemiStat5[_hash2][0] > 2)
			{
				_SemiStat5[_hash2][0]  = (U16) floor(_SemiStat5[_hash2][0] / 2.0 + 1);
			};
		}
		else
		{
			_NonStat1[_ctxIn][1] = 0;
			if (_SemiStat1[_ctxIn][1] > 2 )
			{
				_SemiStat1[_ctxIn][1] = (U16) floor(_SemiStat1[_ctxIn][1] / 2.0 + 1);
			};
			if (_SemiStat2[_hash1][1] > 2)
			{
				_SemiStat2[_hash1][1] = (U16) floor(_SemiStat2[_hash1][1] / 2.0 + 1);
			};
			if (_SemiStat5[_hash2][1] > 2)
			{
				_SemiStat5[_hash2][1]  = (U16) floor(_SemiStat5[_hash2][1] / 2.0 + 1);
			};
		}

		//mise a jours des poids de chaque modele
		// w_i := w_i + e[ny_i/(SUM_j (w_j+wo) ny_j) - n_i/(SUM_j (w_j+wo) n_j)]
		Somme_b = (_poidSS1 + w0) * _SemiStat1[_ctxIn][bit] + (_poidSS2 + w0) * _SemiStat2[_hash1][bit]  + (_poidSS5 + w0) * _SemiStat5[_hash2][bit] + (_poidNS1 + w0) * _NonStat1[_ctxIn][bit]  + (_poidS1 + w0) * _Stat1[_ctxIn][bit];
		Somme   = (_poidSS1 + w0) * (_SemiStat1[_ctxIn][0] + _SemiStat1[_ctxIn][1]) + (_poidSS2 + w0) * (_SemiStat2[_hash1][0] + _SemiStat2[_hash1][1])  + (_poidSS5 + w0) * (_SemiStat5[_hash2][0] + _SemiStat5[_hash2][1]) + (_poidNS1 + w0) * (_NonStat1[_ctxIn][0] + _NonStat1[_ctxIn][1])  + (_poidS1 + w0) *(_Stat1[_ctxIn][1] + _Stat1[_ctxIn][0]);
		if (bit == 1)
		{

			_poidS1  = (_poidS1  + 0.20 * ( _Stat1[_ctxIn][1] / Somme_b - (_Stat1[_ctxIn][1] + _Stat1[_ctxIn][0]) / Somme));
			_poidNS1 = (_poidNS1 + 0.20 * (_NonStat1[_ctxIn][1] / Somme_b - (_NonStat1[_ctxIn][1] + _NonStat1[_ctxIn][2]) / Somme));
			_poidSS1 = (_poidSS1 + 0.20 * (_SemiStat1[_ctxIn][1] / Somme_b - (_SemiStat1[_ctxIn][1] + _SemiStat1[_ctxIn][0]) / Somme));
			_poidSS2 = (_poidSS2 + 0.20 * (_SemiStat2[_hash1][1] / Somme_b - (_SemiStat2[_hash1][1] + _SemiStat2[_hash1][0]) / Somme));
			_poidSS5 = (_poidSS5 + 0.20 * (_SemiStat5[_hash2][1] / Somme_b - (_SemiStat5[_hash2][1] + _SemiStat5[_hash2][0]) / Somme));

		}
		else
		{
			_poidS1  = (_poidS1  + 0.20 * ( _Stat1[_ctxIn][0]  / Somme_b - (_Stat1[_ctxIn][1] + _Stat1[_ctxIn][0]) / Somme));
			_poidNS1 = (_poidNS1 + 0.20 * (_NonStat1[_ctxIn][0] / Somme_b - (_NonStat1[_ctxIn][1] + _NonStat1[_ctxIn][2]) / Somme));
			_poidSS1 = (_poidSS1 + 0.20 * (_SemiStat1[_ctxIn][0] / Somme_b - (_SemiStat1[_ctxIn][1] + _SemiStat1[_ctxIn][0]) / Somme));
			_poidSS2 = (_poidSS2 + 0.20 * (_SemiStat2[_hash1][0] / Somme_b - (_SemiStat2[_hash1][1] + _SemiStat2[_hash1][0]) / Somme));
			_poidSS5 = (_poidSS5 + 0.20 * (_SemiStat5[_hash2][0] / Somme_b - (_SemiStat5[_hash2][1] + _SemiStat5[_hash2][0]) / Somme));
		}

	/*
		_poidS1  =  _poidS1 + 4096 * ( 2 * bit - 1) * 25.0 * ( bit - ( (_Stat1[_ctxIn][1] + 1.0) / ( 2.0 + _Stat1[_ctxIn][1] + _Stat1[_ctxIn][0])));
		_poidNS1 = _poidNS1 + 4096 * ( 2 * bit - 1) * 25.0 * ( bit - ( (_NonStat1[_ctxIn][1] + 1.0) / ( 2.0 + _NonStat1[_ctxIn][1] + _NonStat1[_ctxIn][0])));
		_poidSS1 = _poidSS1 + 4096 * ( 2 * bit - 1) * 25.0 * ( bit - ( (_SemiStat1[_ctxIn][1] + 1.0) / ( 2.0 + _SemiStat1[_ctxIn][1] + _SemiStat1[_ctxIn][0])));
		_poidSS2 = _poidSS2 + 4096 * ( 2 * bit - 1) * 25.0 * ( bit - ( (_SemiStat2[_hash1][1] + 1.0) / ( 2.0 + _SemiStat2[_hash1][1] + _SemiStat2[_hash1][0])));
		_poidSS5 = _poidSS5 + 4096 * ( 2 * bit - 1) * 25.0 * ( bit - ( (_SemiStat5[_hash2][1] + 1.0) / ( 2.0 + _SemiStat5[_hash2][1] + _SemiStat5[_hash2][0])));
	*/

		if ( _poidS1 <= 0)
		{
				_poidS1 = 1;
		};
		if ( _poidNS1 <= 0)
		{
				_poidNS1 = 1;
		};
		if ( _poidSS1 <= 0)
		{
				_poidSS1 = 1;
		};
		if ( _poidSS2 <= 0)
		{
				_poidSS2 = 1;
		};
		if ( _poidSS5 <= 0)
		{
				_poidSS5 = 1;
		};



		//mise a jours du contexte
		_ctxOut = ( _ctxOut << 1) + ((_ctxIn << 1) & 0x1000);
		_ctxIn = ( _ctxIn << 1) + bit;

		//mise a jours du hash
		_hash1 = (U16)(((_ctxOut & 0x000000ff) ^ (_ctxIn >> 5)) & 0xffff);
		_hash2 = (U16)(((_ctxOut  >> 15) ^ (_ctxOut  >> 2) ^ (_ctxIn)) & 0xffff);
	}

	U16 SpeedMix::p()
	{
		return (U16) (4096 *  ( 1.0 + (_Stat1[_ctxIn][1] * _poidS1 + _NonStat1[_ctxIn][1] * _poidNS1 + _SemiStat1[_ctxIn][1] * _poidSS1 + _SemiStat2[_hash1][1] * _poidSS2 + _SemiStat5[_hash2][1] * _poidSS5)) / ( 2.0 + ( (_Stat1[_ctxIn][0] + _Stat1[_ctxIn][1]) * _poidS1 + (_NonStat1[_ctxIn][0] + _NonStat1[_ctxIn][1]) * _poidNS1 + (_SemiStat1[_ctxIn][1] + _SemiStat1[_ctxIn][2]) * _poidSS1 + (_SemiStat2[_hash1][1] + _SemiStat2[_hash1][2]) * _poidSS2 + (_SemiStat5[_hash2][1] + _SemiStat5[_hash2][0]) * _poidSS5)))   ;
	}


}
