/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

/*
** Classe Fichier
**
** 2005-11-29	Arkanosis   Classe, prototypes, premire implmentation
**
** TODO : ---
*/

/*############################*/
#ifndef FICHIER_HPP
#	define FICHIER_HPP
/*############################*/

#include"../definitions.hpp"

#include"FluxBinaire.hpp"
#include"Crc32.hpp"

namespace BigCrunch
{

	/*
	** Description :
	**
	** Constructeurs :
	**
	** Mthodes :
	**
	** Proprits :

	*/

	class Fichier
	{
		public:
			// Constructeurs
			Fichier(const char *nomFichier, ModeFlux mode = LECTURE);
			~Fichier();
			// Mthodes
			void copier(const char *nomEntree);
			static void copier(const char *nomEntree, const char *nomSortie);
			void renommer(const char *nouveauNom);
			static void renommer(const char *ancienNom, const char *nouveauNom);
			void supprimer();
			static void supprimer(const char *nomFichier);
			// Proprits
			bool Existe();
			static bool Existe(const char *nomFichier);
			static bool EstArchive(const char *nomFichier);
			uint Taille();
			static uint Taille(const char *nomFichier);
			U32 Crc32();
			static U32 Crc32(const char *nomFichier);
			static char *NomFichierTemporaire();
			static char *Nommer(const char *idee);
			static char *changerExtension(const char *nomFichier, const char *extension);
			FluxBinaire *GetFlux();

		protected:
			// Champs
			char        *_nomFichier;
			FluxBinaire *_flux;
	};

}

/*############################*/
#endif
/*############################*/
