/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

/*
** Classe Dico
**
** 2005-12-28	Arkanosis   Classe, prototypes, premire implmentation
**
** TODO : ---
*/

/*############################*/
#ifndef DICO_HPP
#	define DICO_HPP
/*############################*/

#include"../definitions.hpp"

namespace BigCrunch
{

	struct MotDico
	{
		int code;
		U32 prefixe;
		U8  caractere;
	};

	/*
	** Description :
	** 	Un dictionnaire est une table de hash.
	**
	** Constructeurs :
	** 	- Dico(int tailleDico)
	** 		Cre un dictionnaire de
	** 	- ~Dico()
	** 		Dtruit le dictionnaire
	**
	** Mthodes :
	**
	** Proprits :
	*/

	class Dico
	{
		public:
			// Constructeurs
			Dico(byte tailleIndex);
			~Dico();
			// Mthodes
			bool ajouter(U32 index, U32 codeChaine, U8 caractere);
			void purger();
			U32  getIndex(U32 codeChaine, U8 caractere);
			U32  getCodeSuivant();
			// Proprits
			bool EstPlein();
			bool Existe(U32 index);
			MotDico & operator [] (int i)
			{
				return *((this->_table) + i);
			}

		protected:
			// Champs
			U32     _codeSuivant;
			byte    _tailleCode;
			U32     _codeMaximum;
			uint    _tailleTable;
			byte    _decalageHash;
			MotDico *_table;

	};

}

/*############################*/
#endif
/*############################*/
