/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

/*
** Classe ###
**
** 2005-##-## Nico tout plein de truc...
** 2005-12-17 Moi_ioM HeapSort, maj des nom de variables,...
**
** TODO : debugger le HeapSort param par defaut dans heapsort a gerer
*/

/*############################*/
#ifndef TABLEAU_HPP
#	define TABLEAU_HPP
/*############################*/

#include"../definitions.hpp"

namespace BigCrunch
{
	/*
	** Description :
	** 	Un tableau dynamique contient des donnes du mme type et peut tre redimensionn.
	**
	** Mthodes :
	** 	- ###(###)
	** 		###
	** 	- ~###()
	** 		Dtruit ###
	*/

	/*
	** Description :
	**  Tab est une classe permettant l'utilisation de tableau dynamique.
	**
	**
	** Declaration : On declare un element de la classe Tab de la maniere suivante :
	**                 Tab<Telem> T(taille) ou Telem est le type/classe  d'element du tableau et taille la taille du tableau
	**		   ATTENTION : les elements du tableau vont de 0 jusqu'a taille-1
	**
	** Mthodes :
	**
	** ( T = instance de la classe Tab)
	**  - Telem & operateur [] (int i) : UTILISATION : T[i]
	**                                   FONCTION    : transmet par reference l'element situ  la place i de T (les elements  allant de 0  T.taille - 1)
	** 		                     NOTE        : Attention aucun test n'est effectuer sur i, pour permettre d'aller plus vite
	**                                                 Il faut donc tester que i ne depasse pas T.taille -1 avant un appel  T[i]
	** - void Taille() :                UTILISATION : T.Taille
	**                                  FONCTION    : Retourne la taille de T
	**
	** - void Init(Telem x) :           UTILISATION : T.Init(x)
	**                                  FONCTION    : Initialise toute les valeurs du tableau  Telem
	** - void InitenIncrementant(Telem x) :
	**                                  UTILISATION : T.InitEnIncrementant(x)
	**                                  FONCTION    : Initialise toute les valeurs du tableau  en partant de x et en augmentant la valeur pour chaque nouvelle case
	**									NOTE        : l'operateur ++ doit etre definie pour le type Telem
	**
	** TODO : Methodes : modifier recopie avec le realloc/egal/realloc
	*/

	template <class Telem> class Tab
	{
		public:
			//Methodes utiles
			Telem & operator [] (int i)
			{
				return *((this->_tab) + i);
			}

			bool operator == (Tab<Telem> a)
			{
				return (memcmp(_tab, a._tab,sizeof(Telem)*_tailleTabMax) == 0);
			}

			bool operator < (Tab<Telem> a)
			{
				return (memcmp(_tab, a._tab,sizeof(Telem)*_tailleTabMax) < 0);
			}

			bool operator > (Tab<Telem> a)
			{
				return (memcmp(_tab, a._tab,sizeof(Telem)*_tailleTabMax) > 0);
			}

			int   Taille()
			{
				return this->_tailleTabMax;
			}

			Telem *AdrTab()
			{
				return _tab;
			}

			void    Init(Telem);
			void 	InitEnIncrementant(Telem x);
			void    ModTaille(int);		// N'est pas encore implementer!!!!!
			void 	swap(Telem &a, Telem &b);
			// HeapSort
			void    HeapSort(int, int); // debut et fin (commence a 0)
			void    HeapSort(int); 		// debut... la fin est la taille max du tableau
			void    HeapSort(); 		// tout le tableau
			// CONSTRUCTEURS....
					Tab(int i);
					~Tab();
					Tab(const Tab &);

		private:
			void    TableauVersTas(Telem*, int);
			void    TasVersTableauTrie(Telem*, int);
			void    ReOrganiseTas(Telem*, int, int);

		protected:
			int   _tailleTabMax; 		//taille
			Telem *_tab;
	};
}
#include"Tableau.cpp"


/*############################*/
#endif
/*############################*/
