/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
**
** TODO gerer les exception de lecture dans les fichier...
** TODO gerer les _bloc supperieurs a 255 motifs (ecrir dans le fichier 2 octets au lieu de 1...)
**		changer les _taille[...] pour qu il puisse recevoir des valeur supperieur a 255...
**		changer les chargement du fichier pour charger des int et non des byte...
**
*/

#include"Brh.hpp"
#define LIMITE 180
#define RAW_LIMITE 256 - LIMITE
#define RLEE_LIMITE LIMITE + 2

namespace BigCrunch
{

// Public //
	// Constructeur
	Brh::Brh(const char *nomFichier, ModeCodeur mode, U32 tailleBloc) : Codeur(nomFichier, mode)
	{
		_tailleBloc  = tailleBloc;
	}

	Brh::Brh(const char *nomFichier, ModeCodeur mode, const char *nomSortie, U32 tailleBloc) : Codeur(nomFichier, mode, nomSortie)
	{
		_tailleBloc  = tailleBloc;
	}
#ifndef SFX

	// Encodeur
	const char *Brh::compresser()
	{

		_bloc = new Tab<U8>(_tailleBloc);
        _tabDesPermutation = new Tab< int >(_tailleBloc);

		// information sur la taille du Bloc
		_sortie->ecrireOctets(&_tailleBloc, 4);

        forever
        {
        	uint i = 0;
            for (i = 0; i < _tailleBloc; ++i) // charge un bloc dans _bloc
            {
            	afficherProgression();

            	try
				{
					(*_bloc)[i] = _entree->lireOctet();
				}
				catch (EFinFichier &)
				{
					break;
				}
            }

            if (i < _tailleBloc) // si fin du fichier d'entree le _bloc n'est pas entier
            {
            	if (i != 0)
            	{
                    _sortie->ecrireOctets(&_tailleBloc, 4); // pour precisser au decompresseur qu il doit reprendre la _tailleBloc

                    delete _tabDesPermutation;

                    _tailleBloc = i;
                    _tabDesPermutation = new Tab< int >(_tailleBloc); // reallouer la bonne taille

                    permutation();

                    HeapSortePointeur();

					U32 tmpDicho = dichoBrh();
                    _sortie->ecrireOctets(&tmpDicho, 4);

					rlee();
				}
				break;
            }
            else
            {
            	// fabrique toues les permutation et les enregistre dans _tabDesPermutation
            	permutation();

				// trie le _tabDesPermutation
				HeapSortePointeur();

				U32 tmpDicho = dichoBrh();
				_sortie->ecrireOctets(&tmpDicho, 4);

				rlee();
            }
        }
        return _nomSortie;
    }
#endif
	// Decodeur
    const char *Brh::decompresser()
    {
        _tailleBloc = _entree->lireU32();

		_bloc = new Tab<U8>(_tailleBloc);
        _tabDesPermutation = new Tab< int >(_tailleBloc);

		forever
        {
        	U32 caseDepart = 0;

			afficherProgression();

        	try
        	{
        		caseDepart = _entree->lireU32();
        		if (caseDepart == _tailleBloc)
                {
                    caseDepart = _entree->lireU32();
                }
        	}
        	catch (EFinFichier &)
        	{
        		break;
        	}

			byte chunk;
			U8 tampon;
        	uint i = 0;
            while (i < _tailleBloc)
            {
            	try
				{
					chunk = _entree->lireOctet();
					if (chunk < LIMITE)
					{
						tampon = _entree->lireOctet();
						for (uint j = 0; j < (byte)(chunk + 3); ++j)
						{
							(*_bloc)[i] = tampon;
							++i;
						}
					}
					else
					{
						chunk = chunk - LIMITE + 1;
						for (uint j = 0; j < chunk; ++j)
						{
							(*_bloc)[i] = _entree->lireOctet();;
							++i;
						}
					}
				}
				catch (EFinFichier &)
				{
					break;
				}
            }

            if (i < _tailleBloc) // fin du fichier le _blocCode n'est pas remplie en entier
            {
                _tailleBloc = i;
                TabAuxDecode(caseDepart);
				break;
            }
            else
            {
				TabAuxDecode(caseDepart);
            }

        }


        return _nomSortie;
    }

// Private //
    // Fabrique toutes les permutations
#ifndef SFX
    void Brh::permutation()
    {
    	(*_tabDesPermutation).InitEnIncrementant(0);
    }

    U8 Brh::accesTabDesPermutation(int i, int j)
    {
    	return ((*_bloc)[((*_tabDesPermutation)[i] + j) % _tailleBloc]);
    }

    int Brh::cmpTDPwithBloc(int n)
    {
		for (uint k = 0; k < _tailleBloc; ++k)
		{
			if (accesTabDesPermutation(n, k) < (*_bloc)[k])
			{
				return -1;
			}
			else
			{
				if (accesTabDesPermutation(n, k) > (*_bloc)[k])
				{
					return 1;
				}
			}
		}
		return 0;
    }

    int Brh::cmpTabDesPermutation(int i1, int i2)
    {
		for (uint k = 0; k < _tailleBloc; ++k)
		{
			if (accesTabDesPermutation(i1, k) < accesTabDesPermutation(i2, k))
			{
				return -1;
			}
			else
			{
				if (accesTabDesPermutation(i1, k) > accesTabDesPermutation(i2, k))
				{
					return 1;
				}
			}
		}
		return 0;
    }

	// Retrouve le _bloc originale dans _tabDesPermutation
    U32 Brh::dichoBrh()
    {
		U32 left = 0;
		U32 right = _tailleBloc - 1;
		U32 milieu;

		while (left <= right)
		{
			milieu = (left + right) / 2;
			switch (cmpTDPwithBloc(milieu))
			{
				case 0: // si trouver
					return milieu;
				case -1: // si _tabDesPermutation[milieu] < _bloc
					left = milieu + 1;
					break;
				case 1: // si _tabDesPermutation[milieu] > _bloc
					right = milieu - 1;
					break;
			}
		}

		printf("On est a une endroit qui n'existe pas\n"); // impossible car le _bloc est forcement dans _tabDesPermutation
		exit(42);
    }

	// HeapSortePointeur pour trie le _tabDesPermutation qui est une tableau de pointeur
	void Brh::HeapSortePointeur()
	{
		TableauVersTasPointeur();
		TasVersTableauTriePointeur();
	}

	void Brh::TableauVersTasPointeur()
	{
		for(int i = _tailleBloc - 1; i >= 0; --i)
		{
			ReOrganiseTasPointeur(i, _tailleBloc);
		}
	}

	void Brh::TasVersTableauTriePointeur()
	{
		for (int i = _tailleBloc - 1; i > 0; --i)
		{
			_tabDesPermutation->swap((*_tabDesPermutation)[0], (*_tabDesPermutation)[i]);
			ReOrganiseTasPointeur(0, i);
		}
	}

	void Brh::ReOrganiseTasPointeur(int w, int tailleTab)
	{
		int i, j;

		j = w;

		do
		{
			i = j;

			if (((2 * i + 1) < tailleTab) && (cmpTabDesPermutation((2 * i + 1), j) == 1))
			{
				j = 2 * i + 1;
			}

			if (((2 * i + 2) < tailleTab) && (cmpTabDesPermutation((2 * i + 2), j) == 1))
			{
				j = 2 * i + 2;
			}

			_tabDesPermutation->swap((*_tabDesPermutation)[i], (*_tabDesPermutation)[j]);
		} while (i != j);
	}
#endif
    // Decode un bloc grace a la casedepart et a la succession de boucle
    void Brh::TabAuxDecode(U32 caseDepart)
    {
        Tab<U32> *tabAscii; // table de tous les caracteres qui retien le nbr de fois qu un char du bloc apparait
        Tab<U32> *C; // dit pour chaque char de bloc si c'est le premier(0) de ce type ou le deuxieme(1)...
        Tab<U32> *M;
        Tab<U8> *res;
        U32 sum, c;

        tabAscii = new Tab<U32>(256);
        tabAscii->Init(0);

        C = new Tab<U32>(_tailleBloc);

        M = new Tab<U32>(256);

        res = new Tab<U8>(_tailleBloc);

        for (uint i = 0; i < _tailleBloc; ++i)
        {
            (*C)[i] = (*tabAscii)[(*_bloc)[i]];
            ++(*tabAscii)[(*_bloc)[i]];
        }

        sum = 0;
        for (int i = 0; i < 256; ++i)
        {
            (*M)[i] = sum;
            sum += (*tabAscii)[i];
        }

        c = caseDepart;
        for (int i = _tailleBloc - 1; i >= 0; --i)
        {
            (*res)[i] = (*_bloc)[c];
            c = (*C)[c] + (*M)[(*_bloc)[c]];
        }

        for (uint i = 0; i < _tailleBloc; ++i)
        {
            _sortie->ecrireOctet((*res)[i]);
        }

        delete tabAscii;
        delete C;
        delete M;
        delete res;
    }
#ifndef SFX
    void Brh::rlee()
    {
		byte rleeChunk = 0;
		byte rawChunk = 0;
		U8 rleeTampon = 0;
		U8 rawTampon[RAW_LIMITE + 1];
		U8 tmpTampon;

		for (uint i = 0; i < _tailleBloc; ++i)
		{

			tmpTampon = accesTabDesPermutation(i, (_tailleBloc - 1));

			if (rleeChunk == 0)
			{
				rleeTampon = tmpTampon;
				rleeChunk = 1;
			}
			else
			{
				if (tmpTampon == rleeTampon)
				{
					++rleeChunk;
					if (rleeChunk == RLEE_LIMITE)
					{
						if (rawChunk != 0)
						{
							_sortie->ecrireOctet(rawChunk + LIMITE - 1);
							for (uint i = 0; i < rawChunk; ++i)
							{
								_sortie->ecrireOctet(rawTampon[i]);
							}
							rawChunk = 0;
						}
						_sortie->ecrireOctet(rleeChunk - 3);
						_sortie->ecrireOctet(rleeTampon);
						rleeChunk = 0;
					}
				}
				else
				{
					if (rleeChunk < 3)
					{
						for (uint j = 0; j < rleeChunk; ++j)
						{
							rawTampon[rawChunk] = rleeTampon;
							++rawChunk;
							if (rawChunk == RAW_LIMITE)
							{
								_sortie->ecrireOctet(rawChunk + LIMITE - 1); // on ecrit un bloc RAW en entier
								for (uint k = 0; k < rawChunk; ++k)
								{
									_sortie->ecrireOctet(rawTampon[k]);
								}
								rawChunk = 0;
							}
						}
					}
					else
					{
						if (rawChunk != 0)
						{
							_sortie->ecrireOctet(rawChunk + LIMITE - 1);
							for (uint i = 0; i < rawChunk; ++i)
							{
								_sortie->ecrireOctet(rawTampon[i]);
							}
							rawChunk = 0;
						}
						_sortie->ecrireOctet(rleeChunk - 3);
						_sortie->ecrireOctet(rleeTampon);
					}

					rleeTampon = tmpTampon;
					rleeChunk = 1;
				}
			}


		}

		// Purger les restes
		if (rleeChunk < 3)
		{
			for (uint j = 0; j < rleeChunk; ++j)
			{
				rawTampon[rawChunk] = rleeTampon;
				++rawChunk;
				if (rawChunk == RAW_LIMITE)
				{
					_sortie->ecrireOctet(rawChunk + LIMITE - 1);
					for (uint k = 0; k < rawChunk; ++k)
					{
						_sortie->ecrireOctet(rawTampon[k]);
					}
					rawChunk = 0;
				}
			}

			if (rawChunk != 0)
			{
				_sortie->ecrireOctet(rawChunk + LIMITE - 1);
				for (uint i = 0; i < rawChunk; ++i)
				{
					_sortie->ecrireOctet(rawTampon[i]);
				}
			}
		}
		else
		{
			if (rawChunk != 0)
			{
				_sortie->ecrireOctet(rawChunk + LIMITE - 1);
				for (uint i = 0; i < rawChunk; ++i)
				{
					_sortie->ecrireOctet(rawTampon[i]);
				}
				rawChunk = 0;
			}
			_sortie->ecrireOctet(rleeChunk - 3);
			_sortie->ecrireOctet(rleeTampon);
		}
    }
#endif

}

