/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

/*
** Classe Lzr
**
** 2005-12-28	Arkanosis   Classe, prototypes, premire implmentation
**
** TODO : ---
*/

/*############################*/
#ifndef LZR_HPP
#	define LZR_HPP
/*############################*/

#include"../definitions.hpp"

#include"Codeur.hpp"
#include"../Structures/Dico.hpp"

namespace BigCrunch
{

	/*
	** Description :
	** 	Un codeur Lzr compresse selon un shma LZ (Lempel Ziv)
	**
	** Constructeurs :
	** 	- Lzr(char *nomFichier, ModeCodeur mode)
	** 		Cre un codeur LZ
	** 	- ~Lzr()
	** 		Dtruit le codeur
	**
	** Mthodes :
	**
	** Proprits :
	*/

	class Lzr : virtual public Codeur
	{
		public:
			// Constructeurs
			Lzr(const char *nomFichier, ModeCodeur mode);
			Lzr(const char *nomFichier, ModeCodeur mode, const char *nomSortie);
			// Mthodes
#ifndef SFX
			const char *compresser(bool preparer = false);
#endif
			const char *decompresser();
			// Proprits

		protected:
			// Mthodes protges
#ifndef SFX
			void preparer();
			void ecrireBitsFlat(U64 bits, U64 masque);
#endif
			U64  lireBitsFlat(U64 masque);
			U8   *decoderChaine(Dico *dictionnaire, U8 *tampon, U32 codeChaine);
			void swapDicos();
			void reajusteCompression();
			void reajusteDecompression();
			// Champs
			byte _tailleCodeMax;
			uint _codeMax;
			Dico *_dicoVide;
			Dico *_dicoPlein;
	};

}

/*############################*/
#endif
/*############################*/
