/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

#include"Lzri.hpp"

namespace BigCrunch
{

	Lzri::Lzri(const char *nomFichier, ModeCodeur mode) : Codeur(nomFichier, mode)
	{

	}


	Lzri::Lzri(const char *nomFichier, ModeCodeur mode, const char *nomSortie) : Codeur(nomFichier, mode, nomSortie)
	{

	}

#ifndef SFX
	const char *Lzri::compresser(bool preparer)
	{
		Fichier *fichierDepart = new Fichier(_entree->NomFichier());
		uint tailleFichierDepart = fichierDepart->Taille();
		delete fichierDepart;

		Lzr *codeur = new Lzr(_entree->NomFichier(), COMPRESSER);
		const char *nomFicherTmp = codeur->compresser(preparer);
		delete codeur;

		Fichier *fichierCompresse = new Fichier(nomFicherTmp);
		uint tailleFichierCompresse = fichierCompresse->Taille();
		delete fichierCompresse;

		FluxBinaire *entree = NULL;

		if (tailleFichierCompresse < tailleFichierDepart)
		{
			_sortie->ecrireOctet(1);
			entree = new FluxBinaire(nomFicherTmp, LECTURE);
		}
		else
		{
			_sortie->ecrireOctet(0);
			entree = new FluxBinaire(_entree->NomFichier(), LECTURE);
		}

		forever
		{
			try
			{
				U8 tampon = entree->lireOctet();
				_sortie->ecrireOctet(tampon);
			}
			catch (EFinFichier &)
			{
				break;
			}
		}

		delete entree;

		fichierCompresse = new Fichier(nomFicherTmp);
		fichierCompresse->supprimer();
		delete fichierCompresse;

		return _nomSortie;
	}
#endif

	const char *Lzri::decompresser()
	{
		if (_entree->lireOctet())
		{
			char *nomFicherTmp = NULL;
			nomFicherTmp = Fichier::NomFichierTemporaire();

			FluxBinaire *sortie = NULL;
			sortie = new FluxBinaire(nomFicherTmp, ECRITURE);

			forever
			{
				try
				{
					U8 tampon = _entree->lireOctet();
					sortie->ecrireOctet(tampon);
				}
				catch (EFinFichier &)
				{
					break;
				}
			}

			delete sortie;

			Lzr *codeur = new Lzr(nomFicherTmp, DECOMPRESSER, _nomSortie);
			_nomSortie = codeur->decompresser();
			delete codeur;

			Fichier fichierCompresse(nomFicherTmp);
			fichierCompresse.supprimer();

			delete nomFicherTmp;
		}
		else
		{
			forever
			{
				try
				{
					U8 tampon = _entree->lireOctet();
					_sortie->ecrireOctet(tampon);
				}
				catch (EFinFichier &)
				{
					break;
				}
			}
		}

		return _nomSortie;
	}

}
