/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

#include"RMAr1.hpp"


namespace BigCrunch
{
	RunMapC::RunMapC(const char *nomFichier, ModeCodeur mode) : Codeur(nomFichier, mode)
	{
		_borneInf = 0;
		_borneSup = 0xffffffff;
	}

#ifndef SFX
	//Gerer le preparer
	const char *RunMapC::compresser()
	{
		U8	 buffer;
		uint taille ;

		//lire la taille et l'ecrire dans le fichier sortie
		taille = _entree->Taille();
		_sortie->ecrireOctets(&taille, sizeof(uint));

		forever
		{
			afficherProgression();

			try
			{
				buffer = _entree->lireOctet();
			}
			catch (EFinFichier &)
			{
				break;
			}
			for ( int i = 7; i >= 0; --i)
			{
				if ((buffer >> i) & 1) //si le bit courant est un 1
				{
					_borneSup = _borneInf + (((_borneSup - _borneInf) >> 12) * P.p());
					P.apprendre(1);
				}
				else
				{
					_borneInf = _borneInf + (((_borneSup - _borneInf) >> 12)  * P.p()) + 1;
					P.apprendre(0);
				}
				while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
				{
					_sortie->ecrireOctet(_borneInf >> 24);
					_borneInf <<= 8;
					_borneSup = (_borneSup << 8) + 0x000000ff;
				}
			}
		}

		while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
		{
			_sortie->ecrireOctet(_borneInf >> 24);
			_borneInf <<= 8;
			_borneSup = (_borneSup << 8) + 0x000000ff;
		}
		//printf("--_borneInf = %u, _borneSup=%u, p(1)=%u\n", _borneInf , _borneSup, P.p());
		_sortie->ecrireOctet(_borneSup  >> 24);
		//_sortie->purger();
		return _nomSortie;
	}
#endif
	const char *RunMapC::decompresser()
	{
		U16  buffer;
		U32  pivot,
			 reel;
		uint *taille = NULL;
		int  i;

		i 	   = 0;
		reel   = 0;
		buffer = 0;
		try
		{
			taille = (uint *) _entree->lireOctets(sizeof(uint));
		}
		catch (EFinFichier &)
		{
			return NULL;
		}

		while (i < 4)
		{
			try
			{
				buffer = _entree->lireOctet();
			}
			catch (EFinFichier &)
			{
				buffer = 0;
			}
			reel = (reel << 8) + buffer;
			buffer = 0;
			++i;
		}
		//i = 0;
		(*taille) *= 8;//pour obtenir la taille en bit
		while ((*taille) > 0)
		{
			afficherProgression();

			--(*taille);
			pivot = _borneInf + (((_borneSup - _borneInf) >> 12) * P.p());
			if ( reel <= pivot)
			{
				_sortie->ecrireBit(1);
				P.apprendre(1);
				_borneSup = pivot;
			}
			else
			{
				_sortie->ecrireBit(0);
				P.apprendre(0);
				_borneInf = pivot + 1;
			}
			while (((_borneInf ^ _borneSup) & 0xff000000) == 0)
			{
				_borneInf <<= 8;
				_borneSup = (_borneSup << 8) + 0x000000ff;
				try
				{
					buffer = _entree->lireOctet();
				}
				catch (EFinFichier &)
				{
					buffer  = 0;
				}
				reel = (reel << 8) + buffer;
			}
		}
		//_sortie->purger();
		return _nomSortie;
	}

}


