/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

#include"SAHuffman.hpp"

namespace BigCrunch
{
    //TODO (Nico#3#): Compression pour petit fichier
    // si un fichier est suffisament petit, ne pas crire d'entete et crire
    // directement informations ncessaire  la construction de l'arbre binaire
    //  la premire apparition du motif binaire.
	// faire aussi une optimisation du temps ncessaire  la comprssion.0


    SAHuffman::SAHuffman(const char *nomFichier, ModeCodeur mode): Codeur(nomFichier, mode)
    {
        _nbCharDiff = 255;                                                      // pour qu'il soit  0 au prochain tour
        _tailleFichier = 0;

        _Occur = new (Tab<ArbreHuffman *>) (256);
        for (int i = 0; i < 256; ++i)
			(*_Occur)[i] = NULL;

        _Acces= new (Tab<ref>) (256);
        for (int i = 0; i < 256; ++i)
        {
            (*_Acces)[i].existe = 0;
            (*_Acces)[i].loc = 0;
        }
        _A = NULL;
    }

    SAHuffman::~SAHuffman()
    {
		if (_A)
        {
            delete _A;
        };

        if (_Occur)
        {
            delete _Occur;
		};


        if (_Acces)
        {
            delete _Acces;
        };
    }

#ifndef SFX
	void tri_bourrin (int deb, Tab<ArbreHuffman *>  *T)
	{
		int min;
		ArbreHuffman * Buf;

		for (int i = deb; i< 256; i++)
		{
			min = i;
			for ( int j = i + 1; j < 256; j++)
			{
				if ( *((*T)[min]) > *((*T)[j]))
				{
					 min = j;
				}
				Buf = (*T)[i];
				(*T)[i] = (*T)[min];
				(*T)[min] = Buf;
			}
		}
	}


    //TODO (Nico#6#): faire une exception lorsque la procedure foire
    void SAHuffman::preparer()
    {
        int i,
			last,
			k;

        U8  buf,
			parc;

        ListeChainee<ArbreHuffman> *L    = NULL,
                                   *Tete = NULL,
                                   *Prec = NULL;
        ArbreHuffman *A = NULL;

        //Initialisation du tableau contenant les occurences
        if (_mode == COMPRESSER)
        {

            forever
            {
                try
                {

                    buf = _entree->lireOctet();

                    if ( ((*_Occur)[buf]) == NULL)
					{
						(*_Occur)[buf] = new ArbreHuffman(buf);
						(*_Acces)[buf].existe = 1;
						++_nbCharDiff;
					};
					++((*_Occur)[buf]->Nb());
					if ((*_Occur)[buf]->Nb() == 0)
					{
						--(*_Occur)[buf]->Nb();
						for ( i = 0; i < 256; ++i)
						{
							if ( (*_Occur)[buf] != NULL )
							{
								(*_Occur)[buf]->Nb() /= 2;
							}
						}
					}

					//TODO (Nico#5#): verifier que la division marche
					++_tailleFichier;

				}
                catch(EFinFichier *expection)
				{
					break;
				}
			}

			//Tri des elements du tab Occur
			_Occur->HeapSort();
			_deb = 0;

			while ( (_deb < 256) && ( (*_Occur)[_deb] == NULL) )
			{
				++_deb;
			}
			//TODO(Nico#4#) Amliorer a!!!!
			tri_bourrin(_deb, _Occur);

			i = 0;
			/*printf("--deb=%d\n", _deb);
			while (i < 256)
			{
				printf("--i=%d --Occur[i]=%d\n", i, (*_Occur)[i]);
				++i;
			}*/

			//TODO (Nico#4#): amelioration de l'actualisation Acces
			 last = 0;
			 for (int j = 256 - _deb; j > 0; --j)
			 {
					for ( i = last; i< 256; ++i)
					{
						if ( (*_Acces)[i].existe )
						{
							k = _deb;
							parc = _deb;
							buf = 1; //ici buf est un booleen qui est vrai tant que l'on n'a pas trouve la place de j)
							while( /*(k < 256) &&*/ buf)
							{
								if ( ((*_Occur)[k] ) && ( (*_Occur)[k]->Carac() == i ) )
								{
									buf = 0;
								}
								++k;
								++parc;
							}
							(*_Acces)[i].loc = parc - 1;
						}
					}
					last = i + 1;
			}


            //transformation de _Occur en liste chainee
            i = _deb;
            if (i < 256)
            {
                Tete = new (ListeChainee<ArbreHuffman>) ( (*_Occur)[i]);
                ++i;
                L = Tete;
                while (i < 256)
                {
                    L->inserer( (*_Occur)[i]) ;
                    L = L->getSuivant();
                    ++i;
                }
            }

        //construction de l'arbre de huffman
			if (Tete)
			{
				L = Tete;

				while( !(Tete->EstUnique()) )
				{
					A = new ArbreHuffman;

					*A = *(Tete->Element()) + *(Tete->getSuivant()->Element()); //fusion entre les 2 arbres contenu dans l'element de la tete et son suivant
					Tete = Tete->supprimer(); //on supprime le premier element
					Tete = Tete->supprimer(); //on supprime le deuxieme

					//reinsertion de A a sa place dans la liste
					L = Tete;
					Prec = NULL;
					while ( !(L->EstVide()) && (*A > *(L->Element()) ))
					{
						Prec = L;
						L = L->getSuivant();
					}
					if (Prec != NULL)
					{
						Prec->inserer(A);
					}
					else
					{
						Tete = Tete->ajouter(A);

					}

				}
				//Le dernier element de la liste a pour element l'arbre de Huffman ..... enfin j'espere
				_A = Tete->Element();
				Tete = Tete->supprimer();

				//on determine le code de chaque feuilles de l'arbre
				_A->DeterminerCode();

				delete Tete;
			}
		}
    }


	bool SAHuffman::encode(ArbreHuffman & C)
	{
			U8 i = C._nbBitCode - 1;
			U32	mark = 1;



			//TODO (Nico#3#) Ameliorer ce truc
			while ( i > 0)
			{
				mark <<= 1;
				--i;
			}

			while ( mark > 0)
			{
				++i;
				if (mark & C._code)
				{
					_sortie->ecrireBit(1);
				}
				else
				{
						_sortie->ecrireBit(0);
				}
				mark >>= 1;
			}

			return 1;
	}

	const char *SAHuffman::compresser(bool preparer)
	{

		int i = 0;
	   // if (preparer)
		this->preparer();


		if (_A)
		{
			_entree->rembobiner();

			//TODO (Nico#1#): gerer les erreurs
			printf(" taille octet : %ld", _tailleFichier);

			_sortie->ecrireOctets(&(_tailleFichier), sizeof(unsigned long) ); //taille du fichier
			_sortie->ecrireOctet(_nbCharDiff);// nombre de caracteres different

			for(i = _deb; i < 256; ++i)
			{
				_sortie->ecrireOctet((*_Occur)[i]->Carac());
				_sortie->ecrireOctet((*_Occur)[i]->_nbBitCode);

				if ( (*_Occur)[i]->_nbBitCode < 9 )
				{
					_sortie->ecrireOctets(&(*_Occur)[i]->_code, sizeof(U8));
				}
				else
				{
					if ( (*_Occur)[i]->_nbBitCode < 17 )
					{
						_sortie->ecrireOctets(&(*_Occur)[i]->_code, sizeof(U16));
					}
					else
					{
						_sortie->ecrireOctets(&(*_Occur)[i]->_code, sizeof(U32));
					}
				}
			}

			if (255 - _deb != _nbCharDiff)
			{
				//TODO(Nico#3#) : lancer une exeption
				printf("erreur %u\n", _nbCharDiff);
				//erreur
			}

			//ecriture du fichier code par huffman
			unsigned long octetlu = 0;
			forever
			{


				try
				{
					i = _entree->lireOctet();
				}
				catch (EFinFichier *exception)
				{
					break;
				}
				encode( *((*_Occur)[ (*_Acces)[i].loc ]) );
				++octetlu;
				//printf("Nb Octet Lu %ld\n", octetlu);

			}
			if (octetlu != _tailleFichier)
					printf("bah a c'est pas cool\n");//TODO (Nico#6#): octetlu = _tailleFichier;
			_sortie->purger();
		}
		return _nomSortie;
	}

	#endif

	//TODO (Nico#5#): insertion : gerer les cas ou l'entete est faux
	ArbreHuffman *insertion(ArbreHuffman *Racine, ArbreHuffman *A)
	{
		U8 i = A->_nbBitCode -1;
		U32 mark = 1;
		ArbreHuffman *P, *N;

		P = Racine;

		//TODO (Nico#3#) Ameliorer ce truc
		while( i > 0)
		{
		  mark <<= 1;
		  --i;
		}


		while (mark > 1)
		{

			if ( (A->Code()) & mark )
			{
				if (P->Fd())
				{
					P = P->Fd();
				}
				else
				{
					N = new ArbreHuffman;
					P->Fd() = N;
					P = N;
				}
			}
			else
			{
				if (P->Fg())
				{
					P = P->Fg();
				}
				else
				{
					N = new ArbreHuffman;
					P->Fg() = N;
					P = N;
				}
			}
			mark >>= 1;
		}


		if ( (A->Code()) & mark )
		{
			P->Fd() = A;
		}
		else
		{
			P->Fg() = A;
		}

		return Racine;
	}

		void Parcour1(ArbreHuffman *A)
			{
				if (A->Fg() == A->Fd())
					printf("Feuille :");

				printf("Carac1 = %c ", A->Carac() );
				printf("Occ = %d\n", A->_code);

				if (A->Fg())
				{
					printf("Fg");
					Parcour1(A->Fg());
				};
				if (A->Fd())
				{
					printf("Fd");
					Parcour1(A->Fd());
				};
			}

	const char *SAHuffman::decompresser()
	{
		unsigned long bitLu = 0;
		char buf;

		ArbreHuffman *A = NULL;


		try
		{	U8  c1;
			U16 c2;


			_tailleFichier = *((unsigned long*) (_entree->lireOctets(sizeof(unsigned long) ))); //taille du fichier
			_nbCharDiff = _entree->lireOctet();// nombre de caracteres differents

			printf(" taille octet : %ld", _tailleFichier);
			printf(" nbCharDiff : %u\n", _nbCharDiff);

			buf = _nbCharDiff + 1;
			_A =	new ArbreHuffman;
			while ( buf > 0)
			{
				//printf("aaa\n");
				A = NULL;
				A = new ArbreHuffman;
				A->Carac() = _entree->lireOctet();

				A->_nbBitCode = _entree->lireOctet();
				if ( A->_nbBitCode < 9 )
				{
					//Todo(Nico#4#) optimiser
					c1 = *( (U8 *) (_entree->lireOctets(sizeof(U8))));
					A->_code = (U32) c1;
				}
				else
				{
					if (A->_nbBitCode < 17)
					{
						//Todo(Nico#4#) optimiser
						c2 = *( (U16 *) (_entree->lireOctets(sizeof(U16))));
						A->_code = (U32) c2;
					}
					else
					{
						A->_code = * ( (U32 *) (_entree->lireOctets(sizeof(U32))));
					}
				}

				_A = insertion( _A, A);
				--buf;
			}
		}
		catch (EFinFichier *exception)
		{
			throw(exception);
			printf("voilapk");
			//bah c pas bien
		}

		//TODO(Nico#1#) : verifier la ligne qui suit
		while (bitLu < _tailleFichier )
		{
			//printf("bitLu : %ld\n",bitLu);
			try
			{
				_sortie->ecrireOctet(decode());
			}
			catch (EFinFichier *exception)
			{
				break;
				printf("fin %ld\n", bitLu);
			}
			++bitLu;
		}
		//_sortie->purger();
		return _nomSortie;
	}

	char SAHuffman::decode()
	{
	//	printf("\n \n---Debut Decodage\n");
		ArbreHuffman *Parc;

		Parc = _A;
		while (Parc->Fd() != Parc->Fg()) //tant que l'on est pas sur une feuille
		{
			//printf("----iteration suiv\n");
			if (_entree->lireBit())
			{
				//printf("----Droite\n");
				Parc = Parc->Fd();
			}
			else
			{
				//printf("----Gauche\n");
				Parc = Parc->Fg();
			}
		}
		//printf("---fin decodage\n");
		return  Parc->Carac();

	}

}
