/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

/*
** Classe Codeur
**
** 2005-12-26	Arkanosis   Classe, prototypes, premire implmentation
**
** TODO : ---
*/

/*############################*/
#ifndef SAHUFFMAN_HPP
#	define SAHUFFMAN_HPP
/*############################*/

#include"../definitions.hpp"

#include"../Structures/Tableau.hpp"
#include"../Structures/ArbreHuffman.hpp"
#include"../Structures/ListeChainee.hpp"

#include"Codeur.hpp"


namespace BigCrunch
{

	/*
	** Description :
	** 	La classe Codeur ne peut pas etre instancie.
	**	Un codeur prend un fichier en entre et le compresse ou le dcompresse suivant le paramtre mode.
	**
	** Constructeurs :
	** 	- Codeur(char *nomF@@ichier, Mode mode)
	**		Cre un codeur  partir de nomFichier, et selon mode.
	** 	- ~Codeur()
	** 		Detruit le codeur.
	**
	** Mthodes :
	** 	- void preparer()
	** 		Effectue une premire passe sur l'entre pour amliorer la compression.
	** 	- char *compresser()
	** 		Compresse l'entre et retourne le nom du fichier de sortie.
	** 	- char *decompresser()
	** 		Dcompresse l'entre et retourne le nom du fichier de sortie.
	**
	** Proprits :
	*/

	struct ref
	{
		bool existe;
		U8   loc;
	};

	class SAHuffman : virtual public Codeur
	{
		public:
			// Constructeurs
			SAHuffman(const char *nomFichier, ModeCodeur mode);
			~SAHuffman();

			// Mthodes
#ifndef SFX
			const char *compresser(bool preparer = true);                             //TODO (Nico#4#) gerer le cas false
#endif
			const char *decompresser();
			// Proprits

		protected:
#ifndef SFX
			bool SAHuffman::encode(ArbreHuffman & C);
#endif
			char decode();
			// Mthodes protges
			void preparer();
			// Champs
			Tab<ArbreHuffman *>  *_Occur;
		    Tab<ref>             *_Acces;
			U8 		              _nbCharDiff;                                  //debut du tableau occupee
			ArbreHuffman         *_A;
			unsigned long         _tailleFichier;
			int                   _deb;





	};

}

/*############################*/
#endif
/*############################*/
