/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

#include"Dossier.hpp"

namespace BigCrunch
{
#ifdef LINUX
//------------------------------------------------------------------------------
// Disons que c'est la partie UNIX

	// Constructeur
	Dossier::Dossier(queue<string> *tabFichiers)								// tabFichiers est considere comme initialise
	{
		_tabChemin = tabFichiers;
		_tabParc   = new queue<string>;
	}

    // enfile un fichier dans tabFihier
    void Dossier::pushFile(string chemin, string fichier)
    {
        chemin.cat(fichier);
        _tabChemin.push(chemin);
    }

    // enfile un dossier dans _tabChemin
    void Dossier::pushDir(string chemin, string dossier)
    {
        chemin.cat(dossier);
        _tabParc.push(chemin);
    }

    // Traitement effectue sur le contenu d'un dossier lors du parcours
    void Dossier::parcTrt(string chemin)
    {
        // Simplifications...
        string curDir("./");
        string parDir("../");

        // Pour la lecture du dossier
		struct dirent *lecture;                                                 // Contenu du dossier ouvert
		DIR *rep;                                                               // structure donnant les infos sur le dossier ouvert
		rep = opendir(current);                                                 // ouverture du repertoire en question
		struct stat bufstat;                                                    // structure contenant des info sur un fichier

		lecture = readdir(rep);
		while (lecture)                                                         // tant que lecture est pas a NUL quoi
		{
			stat(lecture->d_name, &bufstat);                                    // je sais pas trop ce que ca fait ca...
			string buf(lecture->d_name);                                        // conversion du nom char* en string
			if(!((buf == parDir) || (buf == curDir)))
			{
                //TODO (eric:#6#) "/" a la fin d'un chemin ??
                if(S_ISDIR(bufstat.st_mode))                                    // c'est un dossier on l'enfile dans _tabParc
                    pushDir(chemin, buf);
                else                                                            // c'est a enfiler dans _tabChemin pour compression ulterieure
                    pushFile(chemin, buf);
			}
            lecture = readdir(rep);                                             // appel du contenu suivant (rep est ecrase)
		}
		closedir(rep);                                                          // fermeture du repertoire
    }


    // Parcours recursif des repertoire depuis la racine passee en parametre
    void Dossier::parcRec(string rootDir)
    {
        parcTrt(rootdir);

        while (!(_tabParc.empty()))
        {
            parcRec(_tabParc.pop());
        }
    }










#else

// API Win32 on verra plus tard

#endif
}
