/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://www.bcrunch.tk/
*/

#include"parcDossier.hpp"

namespace BigCrunch
{


// Classe Dossier

	// Constructeur
	Dossier::Dossier(string rootDir, queue<FullAndRoot> *input)
	{
		_filesQueue = input;
		_pathQueue 	= new queue<FullAndRoot>;
		_rootDir    = new FullAndRoot(rootDir);
	}

	// Destructeur
	Dossier::~Dossier()
	{
		delete _filesQueue;
		delete _pathQueue;
	}

	// Ajoute les infos d'un fichier  _pathQueue
	void Dossier::pushFile(FullAndRoot file)
	{
		_filesQueue->push(file);
	}

	// Ajoute les infos d'un dossier pour son parcours utlrieur
	void Dossier::pushDir(FullAndRoot dir, string child)
	{
		string pathLevel("/");

		dir._full += (pathLevel + child);
		dir._root += (pathLevel + child);

		_pathQueue->push(dir);
	}

	// Traite chaque dossier de faon  effectuer le parcours
	void Dossier::browseTrt(FullAndRoot current)
	{
		// Pour la lecture du dossier
		struct dirent *lecture;                                                 // Contenu du dossier ouvert
		DIR *rep;                                                               // structure donnant les infos sur le dossier ouvert
		rep = opendir(current._full.c_str());

		if ((!rep) && (Fichier::Existe(current._full.c_str())))					// Test si current est un fichier ou un dossier
		{
			pushFile(current);
		}

		struct stat bufstat;                                                    // structure contenant des info sur un fichier

		lecture = readdir(rep);
		while (lecture)                                                         // tant que lecture est pas a NUL quoi
		{
			stat(lecture->d_name, &bufstat);                                    // visiblement, m'initialisation de bufstat...
			string child(lecture->d_name);                                      // conversion du nom char* en string
			if(!((child == ".")   ||
				 (child == "..")  ||
				 (child == "./")  ||
				 (child == "../") ||
				 (child == "..\\")||
				 (child == ".\\") ))
			{
                pushDir(current, child);
			}
            lecture = readdir(rep);                                             // appel du contenu suivant (rep est ecrase)
		}
		closedir(rep);                                                          // fermeture du repertoire
    }

	// Effectue le parcours depuis le _rootDir
	queue<FullAndRoot> *Dossier::browse()
	{
		browseTrt(*_rootDir);													// Parcours de la racine (cas du fichier ger dans parcTrt()

		while(!_pathQueue->empty())
		{
			browseTrt(_pathQueue->front());
			_pathQueue->pop();
		}

		return _filesQueue;
	}

	// mkPath cr l'arborescence de dossiers passs en parametre sous forme de chemin
	bool Dossier::mkPath(string path)
	{
		int i = 0;																// Compteur du parseur
		string buf;																// Buffer de l'arborescence  creer

		while (path[i] != '\0')
		{
			if ((path[i] == '/') || (path[i] == '\\'))
			{
				buf = path.substr(0, i);

				// Pour la lecture du dossier
//				struct dirent *lecture;                                         // Contenu du dossier ouvert
				DIR *rep;                                                       // structure donnant les infos sur le dossier ouvert
				rep = opendir(buf.c_str());

				if ((!rep) && (!Fichier::Existe(buf.c_str())))					// Test si buf n'existe pas il le cr
				{
//					printf("Il existe pas\n");
					if (mkdir(buf.c_str()))										// S'il est impossible de cr ce dossier ca merde
						return false;
				}
				else
				{
					if (!rep)													// C'est un fichier, l'arborescence est donc termin
					{
//						printf("c'est un fichier\n");
						return true;
					}
//					printf("c'est un dossier existant\n");
				}																// Si c'est un dossier il existe donc pas de probleme
			}
			++i;
		}

		return true;															// Si on a eu l'adresse physique d'un dossier
	}

	// Affiche en console le contenu de _filesQueue
	void Dossier::test()
	{
		printf("CONTENU DE _filesQueue :\n\n");
		while (!_filesQueue->empty())
		{
			printf("_full = %s\n", _filesQueue->front()._full.c_str());
			printf("_root = %s\n\n", _filesQueue->front()._root.c_str());
			_filesQueue->pop();
		}
	}
}
