/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://www.bcrunch.tk/
*/

/*
** Classe Dossier
**
** 2006-18-04	Eric   Classe, prototypes, premire implmentation
**
** TODO : ---
*/

/*############################*/
#ifndef PARCDOSSIER_HPP
#	define PARCDOSSIER_HPP
/*############################*/

#include<sys/stat.h>
#include<dirent.h>
#include"FullAndRoot.hpp"
#include"../Outils/Fichier.hpp"


namespace BigCrunch
{

	/*
	** Description : La classe dossier permet le parcours des sous-dossiers passes
	** 				 en parametres au compresseur. L'appartenance au sous-dossier
	**				 sera specifie dans le nom meme du fichier (exemple : ./toto/bibi0.txt)
	**
	** Constructeurs :
	**	- Dossier initialise les files ncssaires au parcours et la file resultat
	**	et initialise le dossier racine (_rootDir) depuis le parametre.
	**
	** Mthodes :
	**	- parcTrt effectue l'ouverture et le classement des fichiers dans la file
	**	resultat _filesQueue, en mettant  jour la file utilis pour le parcours
	**	_pathQueue ne contenant que les adresses physiques des dossiers  parcourir.
	**
	**	- test permet d'afficher dans la console le contenu de la file resultat
	**	_filesQueue, c'est  dire les fichiers organiss pour la compression.
	**
	** Proprits :
	**	- parcRec effectue le parcours depuis le dossier racine _rootDir et retourne
	**	la file des fichiers organiss pour la compression.
	**
	**	- pushFile enfile l'adresse d'un fichier organis pour la compression dans
	**	la file rsultat, _ filesQueue.
	**
		- pushDir enfile l'adresse d'un dossier dans la file de parcours, _pathQueue.
	*/

	class Dossier
	{
		public :
			// Constructeur
								Dossier(string rootDir, queue<FullAndRoot> *input);
								~Dossier();

			// Mthodes
			queue<FullAndRoot> *browse();
			static bool         mkPath(string path);

			// Proprit
			void 				browseTrt(FullAndRoot current);
			void 				test();

		protected :
			//Mthodes
			void 				pushFile(FullAndRoot file);
			void 				pushDir(FullAndRoot dir, string child);

			queue<FullAndRoot> *_filesQueue;									// File resultat qui contient toutes les adresses des fichiers organises pour la compression
			queue<FullAndRoot> *_pathQueue;										// File utilise pour le parcours de l'arborescence
			FullAndRoot		   *_rootDir;									// Dossier racine pour le parcours
	};
}
#endif
