/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

/*############################*/
#ifndef ARBREHUFFMAN_HPP
#	define ARBREHUFFMAN_HPP
/*############################*/

#include"../definitions.hpp"

#include"Pile.hpp"


namespace BigCrunch
{






		/*
		**
		** Classe  : Arbre de Huffman (Arbre Binaire)
		** Sers pour l'algo de compression .... Huffman
		**
		**  Utilisation : ArbreHuffman A;
		**
		**  Methodes :
		**  DeterminerCode : determine le code de huffman associe a chaque caractere // racine de l'arbre
		**  Decode : Decode le flux binaire jusqu'a obtenir le prochain caractere decoder
		*/
		class ArbreHuffman
		{
			public:

				//*teur
				ArbreHuffman(U8 carac = 0, ArbreHuffman *fg = NULL, ArbreHuffman *fd = NULL)//, ArbreHuffman *pere = NULL)
				{
					_carac     = carac;
					_fd        = fd;
					_fg        = fg;
					_code      = 0;
					_nbBitCode = 0;
					_nbocc     = 0;
				}
				~ArbreHuffman();

				//Prop
				ArbreHuffman * & Fd()
				{
					return _fd;
				}
				ArbreHuffman * & Fg()
				{
					return _fg;
				}
			/*	ArbreHuffman * & Pere()
				{
					return _pere;
				}*/
				U8 & Carac()
				{
					return _carac;
				}
				/*U8 & C()
				{
					return _c;
				}*/
				U32 & Code()
				{
					return _code;
				}
				long & Nb()
				{
					return _nbocc;
				}


				//Methodes
				ArbreHuffman & operator + (ArbreHuffman & fd);//fusion
				friend bool operator > (const ArbreHuffman & A, const ArbreHuffman & B);
				friend bool operator < (const ArbreHuffman & A, const ArbreHuffman & B);
				void DeterminerCode();
				operator long()
				{
					return _nbocc;
				}


				//Membres publique
				U32       _code;     // code de huffman (Utile que pour les feuilles)
				U8		  _nbBitCode;//nombre de bit constituant le code de huffman
			private:
				//Membres
				ArbreHuffman *_fg,
				             *_fd;
				             //*_pere;

				U8         _carac;//donnee du fichier en "brut"

				long      _nbocc; //nombre d'occurence du caractere

		};


		struct AaC
		{
			ArbreHuffman *B;
			U8         Nb;
		};

}

/*############################*/
#endif
/*############################*/
