/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

/*
** Classe ListeChainee
**
** 2005-02-12	H2o   implementation
**
** TODO : ---
*/

/*############################*/
#ifndef FILE_HPP
#	define FILE_HPP
/*############################*/

#include"ListeChainee.hpp"
#include"../definitions.hpp"

namespace BigCrunch
{

	/*
	**	-Constructeurs
	**		-File():
	**			renvoie une file vide
	**		-File(Telem x)
	**			renvoie une file possedant un element x
	**
	**	-Methodes
	**		-enfiler(Telem x)
	**			enfile l'element x  la file courante
	**		-defiler()
	**			defile un element
	**		-EstVide()
	**			renvoie 1 si la file est vide, 0 sinon
	**	-Proprieter
	**		-Premier()
	**			renvoie par reference le premier element de la file
	**	-Note : -Attention on ne defile pas une file vide
	**			-on effectue pas Premier() sur une file vide
	**			-> car on provoque une segmentation fault dans ces 2 cas
	*/

	template <class Telem>
	class File
	{
		public:
			// Constructeurs
			File() : _deb(NULL), _fin(NULL) {}
			File(Telem x);
			//destructeurs
			~File()
			{
				if (_deb != NULL)
				{
					delete _deb;
				}
				if (_fin != NULL)
				{
					delete _fin;
				}
			}

			//Methodes utiles
			void enfiler(Telem x);
			void defiler();
			Telem & Premier();
			int EstVide()
			{
				return ( _deb == NULL);
			}

			protected:
			// Champs
			ListeChainee<Telem> *_deb;
			ListeChainee<Telem>  *_fin;

	};

}

#include"File.cpp"


/*############################*/
#endif
/*############################*/
