/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

namespace BigCrunch
{

	template <class Telem>
	ListeChainee<Telem>::ListeChainee()
	{
		_element = NULL;
		_suivant = NULL;
	}

	template <class Telem>
	ListeChainee<Telem>::ListeChainee(Telem *element, ListeChainee<Telem> *suivant)
	{
		_element = element;

		if (suivant == NULL)
		{
			_suivant = new ListeChainee();
		}
		else
		{
			_suivant = suivant;
		}
	}



	template <class Telem>
	ListeChainee<Telem> *ListeChainee<Telem>::getSuivant()
	{
		return _suivant;
	}

    template <class Telem>
	void ListeChainee<Telem>::setSuivant(ListeChainee<Telem> *suivant)
	{
		_suivant = suivant;
	}

	template <class Telem>
	ListeChainee<Telem> *ListeChainee<Telem>::ajouter(Telem *element)
	{
		return new ListeChainee(element, this);
	}

	template <class Telem>
	void ListeChainee<Telem>::inserer(Telem *element)
	{
		_suivant = new ListeChainee(element, _suivant);
	}

	template <class Telem>
	ListeChainee<Telem> *ListeChainee<Telem>::inverser()
	{
	    ListeChainee *ancienneListe = this;

		ListeChainee *listePrecedente = new ListeChainee();
		ListeChainee *listeTmp;

		while (!ancienneListe->EstVide())
		{
		    listeTmp = ancienneListe->getSuivant();
		    ancienneListe->setSuivant(listePrecedente);
		    listePrecedente = ancienneListe;
		    ancienneListe = listeTmp;
		}

		delete ancienneListe;
		return listePrecedente;
	}

	template <class Telem>
	ListeChainee<Telem> *ListeChainee<Telem>::supprimer()
	{
		ListeChainee<Telem> *listeTmp = _suivant;
		delete this;
		return listeTmp;
	}

	template <class Telem>
	void ListeChainee<Telem>::vider(bool effacerElement)
	{
		/*while (!EstVide())
		{
			if (effacerElement)
			{
				delete *Element();
			}

			supprimer();
		}*/ // TODO (Jems#3#) faire quelquechose qui fonctionne koi !
	}

	template <class Telem>
	Telem *ListeChainee<Telem>::Element()
	{
		return _element;
	}

	template <class Telem>
	bool ListeChainee<Telem>::EstVide()
	{
		return _element == NULL;
	}

	template <class Telem>
	bool ListeChainee<Telem>::EstUnique()
	{
		ListeChainee<Telem> *suivant = getSuivant();
		return suivant->EstVide();
	}

	template <class Telem>
	int ListeChainee<Telem>::NbElements()
	{
		if (EstVide())
		{
			return 0;
		}
		else
		{
			return 1 + _suivant->NbElements();
		}
	}

}

