/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

/*
** Classe ListeChainee
**
** 2005-12-27	Arkanosis   Classe, prototypes, premire implmentation
**
** TODO : ---
*/

/*############################*/
#ifndef LISTECHAINEE_HPP
#	define LISTECHAINEE_HPP
/*############################*/

#include"../definitions.hpp"

namespace BigCrunch
{

	/*
	** Description :
	** 	Une liste chaine stocke des lments du mme type.
	**
	** Constructeurs :
	** 	- ListeChainee()
	** 		Cre une liste chaine
	** 	- ~ListeChainee()
	** 		Dtruit une liste chaine
	**
	** Mthodes :
	** 	- ListeChainee<Telem> *getSuivant()
	** 		Passe  l'lment suivant
	** 	- ListeChainee<Telem> *ajouter(Telem element)
	** 		Ajoute l'lment en tte de liste
	** 	- void inserer(Telem element)
	** 		Insre l'lment aprs l'lment actuel
	** 	- void supprimer()
	** 		Supprimme l'lment courant
	** 	- void vider()
	** 		Vide la liste
	**
	** Proprits :
	** 	- Telem Element()
	** 		Retourne l'lment courant
	** 	- bool EstVide()
	** 		Indique si la liste est vide
	** 	- bool EstUnique()
	** 		Indique si la liste contient un unique lment
	** 	- int NbElements()
	** 		Retourne la longueur de la liste
	*/

	template <class Telem>
	class ListeChainee
	{
		public:
			// Constructeurs
			ListeChainee<Telem>::ListeChainee();
			ListeChainee(Telem *element, ListeChainee<Telem> *suivant = NULL);
			// Mthodes
			ListeChainee<Telem> *getSuivant();
			void setSuivant(ListeChainee<Telem> *suivant);
			ListeChainee<Telem> *ajouter(Telem *element);
			void                inserer(Telem *element);
			ListeChainee<Telem> *inverser();
			ListeChainee<Telem> *supprimer();
			void                vider(bool effacerElement = false);
			// Proprits
			Telem *Element();
			bool  EstVide();
			bool  EstUnique();
			int   NbElements();

		protected:
			// Champs
			Telem               *_element;
			ListeChainee<Telem> *_suivant;
	};

}

#include"ListeChainee.cpp"


/*############################*/
#endif
/*############################*/
