/*
** Big Crunch
** Compresseur exploitable et exprimental
**
** Copyright (C) 2005-2006 - KaBoom
**
** http://bcrunch.online.fr/
*/

/*
** Dfinitions globales
**
** 2005-12-01	Arkanosis	Types de donnes simples, boucle forever
**
** TODO : ---
*/

/* Version des Codeurs
**	(premier octet du header)
**
**  Aucun               0
**	RLE                 1   ->  10
**	Huffman             11  ->  20
**	LZ                  21  ->  60
**	BWT                 61  ->  80
**	PPM                 81  ->  100
**	Arithmetique        101 ->  120
**	Reseau de neurones  121 ->  130
**  Algo gntique      131 ->  140
**
**	Filtre				141 ->  255

**	BCJ2 (remplace les sauts relatifs "10 en avant, 35 en arriere"
**        par des sauts absolus "adresse 0xFF7A")
**
*/

/*############################*/
#ifndef DEFINITIONS_HPP
#	define DEFINITIONS_HPP
/*############################*/

// Enttes standards
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<ctime>
#include<string>
#include<queue>

using namespace std;

/*
** Constantes du programme
*/

#define ENTETE_BCRUNCH 42
#define VERSION_BCRUNCH 2
#define VERSION_BCRUNCH_TXT "0.4 Alpha 1"

#ifdef _WIN32_
	#define NOM_EXE "BigCrunch.exe"
#else
	#define NOM_EXE "BigCrunch"
#endif

/*
** Reglages par defaut
*/

#define DETAILS_PAR_DEFAUT 4
#define MODE_PAR_DEFAUT 2
#define DETAILS_VERBOSE 5
#define DETAILS_QUIET 0
#define REACTION_PAR_DEFAUT 0


/*
** Taille du SFX
*/

#define TAILLE_EXE_WIN32 45056
#define TAILLE_EXE_LINUX 31932
#define TAILLE_EXE_BSD 41984
#define TAILLE_EXE_MACOS 107740


#ifdef _WIN32_
	#define TAILLE_EXE TAILLE_EXE_WIN32
#endif
#ifdef _LINUX_
	#define TAILLE_EXE TAILLE_EXE_LINUX
#endif
#ifdef _BSD_
	#define TAILLE_EXE TAILLE_EXE_BSD
#endif
#ifdef _MACOS_
	#define TAILLE_EXE TAILLE_EXE_MACOS
#endif



/*
** Types de donnes simples
*/


typedef unsigned char           byte;  // Plus rapide et smantiquement correct
typedef unsigned short int      word;  // Plus rapide
typedef unsigned int            uint;  // Plus rapide
typedef unsigned long int       ulong; // Plus rapide

typedef unsigned char           U8;    // Fonctionnel
#define MAX_U8                  0xffU;
typedef unsigned short int      U16;   // Fonctionnalit incertaine sous 64 bits
#define MAX_U16                 0xffffU;
typedef unsigned int            U32;   // Fonctionnalit incertaine sous 16 ou 64 bits
#define MAX_U32                 0xffffffffU;
typedef unsigned long long int  U64;   // Thoriquement fonctionnel
#define MAX_U64                 0xffffffffffffffffULL;

typedef signed char             S8;    // Fonctionnel
#define MAX_S8                  127;
typedef signed short int        S16;   // Fonctionnalit incertaine sous 64 bits
#define MAX_S16                 32767;
typedef signed int              S32;   // Fonctionnalit incertaine sous 16 ou 64 bits
#define MAX_S32                 2147483647;
typedef signed long long int    S64;   // Thoriquement fonctionnel
#define MAX_S64                 9223372036854775807LL;


/*
** Langues
*/

enum Langue
{
	FR,
	EN,
	DE
};


/*
** Structures de contrle
*/

#define forever for (;;)       // Plus explicite (NB : "while (true)" n'est pas optimis par VS)
#define never   while (false)  // Useless ?


/*
** Fonctions moches  inliner
*/

#define printl(texte)                            \
{                                                \
	if (parametres.logger)                       \
	{                                            \
		fprintf(parametres.logf, "%s\n", texte); \
	}                                            \
}

/*
** Constantes usuelles du bytecode
*/

#ifndef EOF
	#define EOF 255  // End Of File
#endif
#define NUL 0    // Null
#define SOH 1    // Start Of Heading
#define STX 2    // Start Of Text
#define ETX 3    // End Of Text
#define EOT 4    // End Of Transmission
#define ENQ 5    // Enquiry
#define ACK 6    // Acknowledge
#define BEL 7    // Bell
#define BS  8    // Backspace
#define TAB 9    // Horizontal Tab
#define LF  10   // Line Feed
#define VT  11   // Vertical Tab
#define FF  12   // Form Feed
#define CR  13   // Carriage Return
#define SO  14   // Shift Out
#define SI  15   // Shift In
#define DLE 16   // Data Link Escape
#define DC1 17   // Device Control 1
#define DC2 18   // Device Control 2
#define DC3 19   // Device Control 3
#define DC4 20   // Device Control 4
#define NAK 21   // Negative Acknowledge
#define SYN 22   // Synchronous Idle
#define ETB 23   // End Of Transmission Block
#define CAN 24   // Cancel
#define EM  25   // End Of Medium
#define SUB 26   // Substitute
#define ESC 27   // Escape
#define FS  28   // File Separator
#define GS  29   // Group Separator
#define RS  30   // Record Separator
#define US  31   // Unit Separator

/*############################*/
#endif
/*############################*/
